/* FileStore.c generated by valac 0.56.13, the Vala compiler
 * generated from FileStore.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Michael Terry
 */

#include <glib-object.h>
#include <gio/gio.h>
#include "deja.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_FILE_STORE (file_store_get_type ())
#define FILE_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_STORE, FileStore))
#define FILE_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_STORE, FileStoreClass))
#define IS_FILE_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_STORE))
#define IS_FILE_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_STORE))
#define FILE_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_STORE, FileStoreClass))

typedef struct _FileStore FileStore;
typedef struct _FileStoreClass FileStoreClass;
typedef struct _FileStorePrivate FileStorePrivate;

#define FILE_STORE_TYPE_ITEM (file_store_item_get_type ())
#define FILE_STORE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILE_STORE_TYPE_ITEM, FileStoreItem))
#define FILE_STORE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILE_STORE_TYPE_ITEM, FileStoreItemClass))
#define FILE_STORE_IS_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILE_STORE_TYPE_ITEM))
#define FILE_STORE_IS_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILE_STORE_TYPE_ITEM))
#define FILE_STORE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILE_STORE_TYPE_ITEM, FileStoreItemClass))

typedef struct _FileStoreItem FileStoreItem;
typedef struct _FileStoreItemClass FileStoreItemClass;
enum  {
	FILE_STORE_0_PROPERTY,
	FILE_STORE_TREE_PROPERTY,
	FILE_STORE_CAN_GO_UP_PROPERTY,
	FILE_STORE_SEARCH_FILTER_PROPERTY,
	FILE_STORE_NUM_PROPERTIES
};
static GParamSpec* file_store_properties[FILE_STORE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _FileStoreItemPrivate FileStoreItemPrivate;
enum  {
	FILE_STORE_ITEM_0_PROPERTY,
	FILE_STORE_ITEM_NODE_PROPERTY,
	FILE_STORE_ITEM_FILENAME_PROPERTY,
	FILE_STORE_ITEM_COLLATE_KEY_PROPERTY,
	FILE_STORE_ITEM_PATH_PROPERTY,
	FILE_STORE_ITEM_ICON_PROPERTY,
	FILE_STORE_ITEM_EMBLEM_PROPERTY,
	FILE_STORE_ITEM_NUM_PROPERTIES
};
static GParamSpec* file_store_item_properties[FILE_STORE_ITEM_NUM_PROPERTIES];

struct _FileStore {
	GObject parent_instance;
	FileStorePrivate * priv;
};

struct _FileStoreClass {
	GObjectClass parent_class;
};

struct _FileStorePrivate {
	DejaDupFileTree* _tree;
	gboolean _can_go_up;
	gchar* _search_filter;
	DejaDupFileTreeNode* current;
	GPtrArray* items;
};

struct _Block4Data {
	int _ref_count_;
	FileStore* self;
	gchar** needle_tokens;
	gint needle_tokens_length1;
};

struct _Block5Data {
	int _ref_count_;
	GPtrArray* self;
	GCompareFunc compare_func;
};

struct _FileStoreItem {
	GObject parent_instance;
	FileStoreItemPrivate * priv;
};

struct _FileStoreItemClass {
	GObjectClass parent_class;
};

struct _FileStoreItemPrivate {
	DejaDupFileTreeNode* _node;
	gchar* _collate_key;
	gchar* _path;
	GIcon* _icon;
	GIcon* _emblem;
};

static gint FileStore_private_offset;
static gpointer file_store_parent_class = NULL;
static gint FileStoreItem_private_offset;
static gpointer file_store_item_parent_class = NULL;
static GListModelInterface * file_store_g_list_model_parent_iface = NULL;

VALA_EXTERN GType file_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FileStore, g_object_unref)
VALA_EXTERN GType file_store_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FileStoreItem, g_object_unref)
VALA_EXTERN void file_store_clear (FileStore* self);
static gint file_store_clear_full (FileStore* self);
VALA_EXTERN void file_store_register_operation (FileStore* self,
                                    DejaDupOperationFiles* op);
static void file_store_set_tree (FileStore* self,
                          DejaDupFileTree* value);
static void file_store_handle_listed_files (FileStore* self,
                                     DejaDupOperationFiles* op,
                                     DejaDupFileTree* tree);
static void _file_store_handle_listed_files_deja_dup_operation_files_listed_current_files (DejaDupOperationFiles* _sender,
                                                                                    DejaDupFileTree* tree,
                                                                                    gpointer self);
VALA_EXTERN gboolean file_store_go_down (FileStore* self,
                             guint position);
VALA_EXTERN DejaDupFileTreeNode* file_store_item_get_node (FileStoreItem* self);
static void file_store_set_current (FileStore* self,
                             DejaDupFileTreeNode* node);
VALA_EXTERN gboolean file_store_go_up (FileStore* self);
VALA_EXTERN gboolean file_store_get_can_go_up (FileStore* self);
VALA_EXTERN GFile* file_store_get_file (FileStore* self,
                            guint position);
static gchar* file_store_get_full_path (FileStore* self,
                                 guint position);
static GType file_store_real_get_item_type (GListModel* base);
static guint file_store_real_get_n_items (GListModel* base);
static GObject* file_store_real_get_item (GListModel* base,
                                   guint position);
VALA_EXTERN DejaDupFileTree* file_store_get_tree (FileStore* self);
VALA_EXTERN const gchar* file_store_item_get_path (FileStoreItem* self);
VALA_EXTERN const gchar* file_store_item_get_filename (FileStoreItem* self);
static void file_store_update_search (FileStore* self);
VALA_EXTERN const gchar* file_store_get_search_filter (FileStore* self);
static void file_store_recursive_search (FileStore* self,
                                  gchar** needle_tokens,
                                  gint needle_tokens_length1,
                                  DejaDupFileTreeNode* node);
static void file_store_sort (FileStore* self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda16_ (Block4Data* _data4_,
                  const gchar* name,
                  DejaDupFileTreeNode* child);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static void file_store_insert_file (FileStore* self,
                             DejaDupFileTreeNode* node);
static void ___lambda16__gh_func (gconstpointer key,
                           gconstpointer value,
                           gpointer self);
static void file_store_set_can_go_up (FileStore* self,
                               gboolean value);
static void __lambda14_ (FileStore* self,
                  const gchar* name,
                  DejaDupFileTreeNode* child);
static void ___lambda14__gh_func (gconstpointer key,
                           gconstpointer value,
                           gpointer self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static gint ___lambda0__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
static gint __lambda15_ (FileStoreItem* a,
                  FileStoreItem* b);
VALA_EXTERN const gchar* file_store_item_get_collate_key (FileStoreItem* self);
static gint ___lambda15__gcompare_func (gconstpointer a,
                                 gconstpointer b);
VALA_EXTERN FileStoreItem* file_store_item_new (DejaDupFileTreeNode* node,
                                    const gchar* collate_key,
                                    const gchar* path,
                                    GIcon* icon,
                                    GIcon* emblem);
VALA_EXTERN FileStoreItem* file_store_item_construct (GType object_type,
                                          DejaDupFileTreeNode* node,
                                          const gchar* collate_key,
                                          const gchar* path,
                                          GIcon* icon,
                                          GIcon* emblem);
VALA_EXTERN FileStore* file_store_new (void);
VALA_EXTERN FileStore* file_store_construct (GType object_type);
VALA_EXTERN void file_store_set_search_filter (FileStore* self,
                                   const gchar* value);
static void file_store_item_set_node (FileStoreItem* self,
                               DejaDupFileTreeNode* value);
static void file_store_item_set_collate_key (FileStoreItem* self,
                                      const gchar* value);
static void file_store_item_set_path (FileStoreItem* self,
                               const gchar* value);
VALA_EXTERN GIcon* file_store_item_get_icon (FileStoreItem* self);
static void file_store_item_set_icon (FileStoreItem* self,
                               GIcon* value);
VALA_EXTERN GIcon* file_store_item_get_emblem (FileStoreItem* self);
static void file_store_item_set_emblem (FileStoreItem* self,
                                 GIcon* value);
static void file_store_item_finalize (GObject * obj);
static GType file_store_item_get_type_once (void);
static void _vala_file_store_item_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_file_store_item_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static GObject * file_store_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static void _g_object_unref0_ (gpointer var);
static void _file_store_update_search_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self);
static void file_store_finalize (GObject * obj);
static GType file_store_get_type_once (void);
static void _vala_file_store_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_file_store_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
file_store_get_instance_private (FileStore* self)
{
	return G_STRUCT_MEMBER_P (self, FileStore_private_offset);
}

void
file_store_clear (FileStore* self)
{
	gint removed = 0;
#line 15 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 16 "../app/FileStore.vala"
	removed = file_store_clear_full (self);
#line 17 "../app/FileStore.vala"
	g_list_model_items_changed ((GListModel*) self, (guint) 0, (guint) removed, (guint) 0);
#line 276 "FileStore.c"
}

static void
_file_store_handle_listed_files_deja_dup_operation_files_listed_current_files (DejaDupOperationFiles* _sender,
                                                                               DejaDupFileTree* tree,
                                                                               gpointer self)
{
#line 26 "../app/FileStore.vala"
	file_store_handle_listed_files ((FileStore*) self, _sender, tree);
#line 286 "FileStore.c"
}

void
file_store_register_operation (FileStore* self,
                               DejaDupOperationFiles* op)
{
#line 20 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 20 "../app/FileStore.vala"
	g_return_if_fail (op != NULL);
#line 22 "../app/FileStore.vala"
	_g_object_unref0 (self->priv->current);
#line 22 "../app/FileStore.vala"
	self->priv->current = NULL;
#line 23 "../app/FileStore.vala"
	file_store_set_tree (self, NULL);
#line 25 "../app/FileStore.vala"
	file_store_clear (self);
#line 26 "../app/FileStore.vala"
	g_signal_connect_object (op, "listed-current-files", (GCallback) _file_store_handle_listed_files_deja_dup_operation_files_listed_current_files, self, 0);
#line 307 "FileStore.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 31 "../app/FileStore.vala"
	return self ? g_object_ref (self) : NULL;
#line 315 "FileStore.c"
}

gboolean
file_store_go_down (FileStore* self,
                    guint position)
{
	DejaDupFileTreeNode* child = NULL;
	GPtrArray* _tmp0_;
	gconstpointer _tmp1_;
	DejaDupFileTreeNode* _tmp2_;
	DejaDupFileTreeNode* _tmp3_;
	DejaDupFileTreeNode* _tmp4_;
	DejaDupFileTreeNode* _tmp5_;
	GFileType _tmp6_;
	GFileType _tmp7_;
	DejaDupFileTreeNode* _tmp8_;
	gboolean result;
#line 29 "../app/FileStore.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../app/FileStore.vala"
	_tmp0_ = self->priv->items;
#line 31 "../app/FileStore.vala"
	_tmp1_ = g_ptr_array_index (_tmp0_, position);
#line 31 "../app/FileStore.vala"
	_tmp2_ = file_store_item_get_node ((FileStoreItem*) _tmp1_);
#line 31 "../app/FileStore.vala"
	_tmp3_ = _tmp2_;
#line 31 "../app/FileStore.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 31 "../app/FileStore.vala"
	child = _tmp4_;
#line 32 "../app/FileStore.vala"
	_tmp5_ = child;
#line 32 "../app/FileStore.vala"
	_tmp6_ = deja_dup_file_tree_node_get_kind (_tmp5_);
#line 32 "../app/FileStore.vala"
	_tmp7_ = _tmp6_;
#line 32 "../app/FileStore.vala"
	if (_tmp7_ != G_FILE_TYPE_DIRECTORY) {
#line 33 "../app/FileStore.vala"
		result = FALSE;
#line 33 "../app/FileStore.vala"
		_g_object_unref0 (child);
#line 33 "../app/FileStore.vala"
		return result;
#line 361 "FileStore.c"
	}
#line 35 "../app/FileStore.vala"
	_tmp8_ = child;
#line 35 "../app/FileStore.vala"
	file_store_set_current (self, _tmp8_);
#line 36 "../app/FileStore.vala"
	result = TRUE;
#line 36 "../app/FileStore.vala"
	_g_object_unref0 (child);
#line 36 "../app/FileStore.vala"
	return result;
#line 373 "FileStore.c"
}

gboolean
file_store_go_up (FileStore* self)
{
	gboolean _tmp0_;
	DejaDupFileTreeNode* _tmp1_;
	DejaDupFileTreeNode* _tmp2_;
	DejaDupFileTreeNode* _tmp3_;
	gboolean result;
#line 39 "../app/FileStore.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../app/FileStore.vala"
	_tmp0_ = self->priv->_can_go_up;
#line 41 "../app/FileStore.vala"
	if (!_tmp0_) {
#line 42 "../app/FileStore.vala"
		result = FALSE;
#line 42 "../app/FileStore.vala"
		return result;
#line 394 "FileStore.c"
	}
#line 44 "../app/FileStore.vala"
	_tmp1_ = self->priv->current;
#line 44 "../app/FileStore.vala"
	_tmp2_ = deja_dup_file_tree_node_get_parent (_tmp1_);
#line 44 "../app/FileStore.vala"
	_tmp3_ = _tmp2_;
#line 44 "../app/FileStore.vala"
	file_store_set_current (self, _tmp3_);
#line 45 "../app/FileStore.vala"
	result = TRUE;
#line 45 "../app/FileStore.vala"
	return result;
#line 408 "FileStore.c"
}

GFile*
file_store_get_file (FileStore* self,
                     guint position)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* result;
#line 48 "../app/FileStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../app/FileStore.vala"
	_tmp0_ = file_store_get_full_path (self, position);
#line 50 "../app/FileStore.vala"
	_tmp1_ = _tmp0_;
#line 50 "../app/FileStore.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 50 "../app/FileStore.vala"
	_tmp3_ = _tmp2_;
#line 50 "../app/FileStore.vala"
	_g_free0 (_tmp1_);
#line 50 "../app/FileStore.vala"
	result = _tmp3_;
#line 50 "../app/FileStore.vala"
	return result;
#line 436 "FileStore.c"
}

static GType
file_store_real_get_item_type (GListModel* base)
{
	FileStore * self;
	GType result;
#line 55 "../app/FileStore.vala"
	self = (FileStore*) base;
#line 56 "../app/FileStore.vala"
	result = DEJA_DUP_FILE_TREE_TYPE_NODE;
#line 56 "../app/FileStore.vala"
	return result;
#line 450 "FileStore.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5893 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5894 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5894 "glib-2.0.vapi"
	return result;
#line 463 "FileStore.c"
}

static guint
file_store_real_get_n_items (GListModel* base)
{
	FileStore * self;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint result;
#line 59 "../app/FileStore.vala"
	self = (FileStore*) base;
#line 60 "../app/FileStore.vala"
	_tmp0_ = self->priv->items;
#line 60 "../app/FileStore.vala"
	_tmp1_ = vala_g_ptr_array_get_length (_tmp0_);
#line 60 "../app/FileStore.vala"
	_tmp2_ = _tmp1_;
#line 60 "../app/FileStore.vala"
	result = (guint) _tmp2_;
#line 60 "../app/FileStore.vala"
	return result;
#line 486 "FileStore.c"
}

static GObject*
file_store_real_get_item (GListModel* base,
                          guint position)
{
	FileStore * self;
	GPtrArray* _tmp0_;
	gconstpointer _tmp1_;
	GObject* _tmp2_;
	GObject* result;
#line 63 "../app/FileStore.vala"
	self = (FileStore*) base;
#line 64 "../app/FileStore.vala"
	_tmp0_ = self->priv->items;
#line 64 "../app/FileStore.vala"
	_tmp1_ = g_ptr_array_index (_tmp0_, position);
#line 64 "../app/FileStore.vala"
	_tmp2_ = _g_object_ref0 ((GObject*) ((FileStoreItem*) _tmp1_));
#line 64 "../app/FileStore.vala"
	result = _tmp2_;
#line 64 "../app/FileStore.vala"
	return result;
#line 510 "FileStore.c"
}

static gint
file_store_clear_full (FileStore* self)
{
	gint old_len = 0;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GPtrArray* _tmp3_;
	gint result;
#line 94 "../app/FileStore.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 95 "../app/FileStore.vala"
	_tmp0_ = self->priv->items;
#line 95 "../app/FileStore.vala"
	_tmp1_ = vala_g_ptr_array_get_length (_tmp0_);
#line 95 "../app/FileStore.vala"
	_tmp2_ = _tmp1_;
#line 95 "../app/FileStore.vala"
	old_len = _tmp2_;
#line 96 "../app/FileStore.vala"
	_tmp3_ = self->priv->items;
#line 96 "../app/FileStore.vala"
	g_ptr_array_remove_range (_tmp3_, (guint) 0, (guint) old_len);
#line 97 "../app/FileStore.vala"
	result = old_len;
#line 97 "../app/FileStore.vala"
	return result;
#line 540 "FileStore.c"
}

static gchar*
file_store_get_full_path (FileStore* self,
                          guint position)
{
	FileStoreItem* item = NULL;
	GPtrArray* _tmp0_;
	gconstpointer _tmp1_;
	FileStoreItem* _tmp2_;
	gchar* node_path = NULL;
	DejaDupFileTree* _tmp3_;
	DejaDupFileTree* _tmp4_;
	DejaDupFileTreeNode* _tmp5_;
	DejaDupFileTreeNode* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* result;
#line 100 "../app/FileStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../app/FileStore.vala"
	_tmp0_ = self->priv->items;
#line 102 "../app/FileStore.vala"
	_tmp1_ = g_ptr_array_index (_tmp0_, position);
#line 102 "../app/FileStore.vala"
	_tmp2_ = _g_object_ref0 ((FileStoreItem*) _tmp1_);
#line 102 "../app/FileStore.vala"
	item = _tmp2_;
#line 103 "../app/FileStore.vala"
	_tmp3_ = self->priv->_tree;
#line 103 "../app/FileStore.vala"
	_tmp4_ = self->priv->_tree;
#line 103 "../app/FileStore.vala"
	_tmp5_ = deja_dup_file_tree_get_root (_tmp4_);
#line 103 "../app/FileStore.vala"
	_tmp6_ = _tmp5_;
#line 103 "../app/FileStore.vala"
	_tmp7_ = deja_dup_file_tree_node_to_path (_tmp3_, _tmp6_);
#line 103 "../app/FileStore.vala"
	node_path = _tmp7_;
#line 104 "../app/FileStore.vala"
	_tmp8_ = file_store_item_get_path (item);
#line 104 "../app/FileStore.vala"
	_tmp9_ = _tmp8_;
#line 104 "../app/FileStore.vala"
	_tmp10_ = file_store_item_get_filename (item);
#line 104 "../app/FileStore.vala"
	_tmp11_ = _tmp10_;
#line 104 "../app/FileStore.vala"
	_tmp12_ = g_build_filename ("/", node_path, _tmp9_, _tmp11_, NULL);
#line 104 "../app/FileStore.vala"
	result = _tmp12_;
#line 104 "../app/FileStore.vala"
	_g_free0 (node_path);
#line 104 "../app/FileStore.vala"
	_g_object_unref0 (item);
#line 104 "../app/FileStore.vala"
	return result;
#line 603 "FileStore.c"
}

static void
file_store_update_search (FileStore* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gchar** needle_tokens = NULL;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint needle_tokens_length1;
	gint _needle_tokens_size_;
	gint removed = 0;
	gchar** _tmp7_;
	gint _tmp7__length1;
	DejaDupFileTree* _tmp8_;
	DejaDupFileTreeNode* _tmp9_;
	DejaDupFileTreeNode* _tmp10_;
	GPtrArray* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
#line 107 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 109 "../app/FileStore.vala"
	_tmp1_ = self->priv->_search_filter;
#line 109 "../app/FileStore.vala"
	if (_tmp1_ == NULL) {
#line 109 "../app/FileStore.vala"
		_tmp0_ = TRUE;
#line 634 "FileStore.c"
	} else {
		const gchar* _tmp2_;
#line 109 "../app/FileStore.vala"
		_tmp2_ = self->priv->_search_filter;
#line 109 "../app/FileStore.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
#line 641 "FileStore.c"
	}
#line 109 "../app/FileStore.vala"
	if (_tmp0_) {
#line 645 "FileStore.c"
		DejaDupFileTreeNode* _tmp3_;
#line 110 "../app/FileStore.vala"
		_tmp3_ = self->priv->current;
#line 110 "../app/FileStore.vala"
		file_store_set_current (self, _tmp3_);
#line 111 "../app/FileStore.vala"
		return;
#line 653 "FileStore.c"
	}
#line 114 "../app/FileStore.vala"
	_tmp4_ = self->priv->_search_filter;
#line 114 "../app/FileStore.vala"
	_tmp6_ = _tmp5_ = g_str_tokenize_and_fold (_tmp4_, "", NULL);
#line 114 "../app/FileStore.vala"
	needle_tokens = _tmp6_;
#line 114 "../app/FileStore.vala"
	needle_tokens_length1 = _vala_array_length (_tmp5_);
#line 114 "../app/FileStore.vala"
	_needle_tokens_size_ = needle_tokens_length1;
#line 116 "../app/FileStore.vala"
	removed = file_store_clear_full (self);
#line 117 "../app/FileStore.vala"
	_tmp7_ = needle_tokens;
#line 117 "../app/FileStore.vala"
	_tmp7__length1 = needle_tokens_length1;
#line 117 "../app/FileStore.vala"
	_tmp8_ = self->priv->_tree;
#line 117 "../app/FileStore.vala"
	_tmp9_ = deja_dup_file_tree_get_root (_tmp8_);
#line 117 "../app/FileStore.vala"
	_tmp10_ = _tmp9_;
#line 117 "../app/FileStore.vala"
	file_store_recursive_search (self, _tmp7_, (gint) _tmp7__length1, _tmp10_);
#line 118 "../app/FileStore.vala"
	file_store_sort (self);
#line 119 "../app/FileStore.vala"
	_tmp11_ = self->priv->items;
#line 119 "../app/FileStore.vala"
	_tmp12_ = vala_g_ptr_array_get_length (_tmp11_);
#line 119 "../app/FileStore.vala"
	_tmp13_ = _tmp12_;
#line 119 "../app/FileStore.vala"
	g_list_model_items_changed ((GListModel*) self, (guint) 0, (guint) removed, (guint) _tmp13_);
#line 107 "../app/FileStore.vala"
	needle_tokens = (_vala_array_free (needle_tokens, needle_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 691 "FileStore.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 122 "../app/FileStore.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 122 "../app/FileStore.vala"
	return _data4_;
#line 701 "FileStore.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 122 "../app/FileStore.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 711 "FileStore.c"
		FileStore* self;
#line 122 "../app/FileStore.vala"
		self = _data4_->self;
#line 122 "../app/FileStore.vala"
		_g_object_unref0 (self);
#line 122 "../app/FileStore.vala"
		g_slice_free (Block4Data, _data4_);
#line 719 "FileStore.c"
	}
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 134 "../app/FileStore.vala"
	if (length >= 0) {
#line 729 "FileStore.c"
		gchar** result;
		gssize i;
#line 134 "../app/FileStore.vala"
		result = g_new0 (gchar*, length + 1);
#line 134 "../app/FileStore.vala"
		for (i = 0; i < length; i++) {
#line 736 "FileStore.c"
			gchar* _tmp0_;
#line 134 "../app/FileStore.vala"
			_tmp0_ = g_strdup (self[i]);
#line 134 "../app/FileStore.vala"
			result[i] = _tmp0_;
#line 742 "FileStore.c"
		}
#line 134 "../app/FileStore.vala"
		return result;
#line 746 "FileStore.c"
	}
#line 134 "../app/FileStore.vala"
	return NULL;
#line 750 "FileStore.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 769 "FileStore.c"
}

static void
__lambda16_ (Block4Data* _data4_,
             const gchar* name,
             DejaDupFileTreeNode* child)
{
	FileStore* self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gboolean all_matched = FALSE;
#line 124 "../app/FileStore.vala"
	self = _data4_->self;
#line 124 "../app/FileStore.vala"
	g_return_if_fail (name != NULL);
#line 124 "../app/FileStore.vala"
	g_return_if_fail (child != NULL);
#line 126 "../app/FileStore.vala"
	_tmp0_ = child->search_tokens;
#line 126 "../app/FileStore.vala"
	_tmp0__length1 = child->search_tokens_length1;
#line 126 "../app/FileStore.vala"
	if (_tmp0_ == NULL) {
#line 793 "FileStore.c"
		gchar** unicode_tokens = NULL;
		gint unicode_tokens_length1 = 0;
		gint _unicode_tokens_size_ = 0;
		gchar** ascii_tokens = NULL;
		gint ascii_tokens_length1 = 0;
		gint _ascii_tokens_size_ = 0;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar** _tmp3_ = NULL;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gchar** all_tokens = NULL;
		gchar** _tmp6_;
		gint _tmp6__length1;
		gchar** _tmp7_;
		gint _tmp7__length1;
		gchar** _tmp8_;
		gint all_tokens_length1;
		gint _all_tokens_size_;
		gchar** _tmp24_;
		gint _tmp24__length1;
		gchar** _tmp25_;
		gint _tmp25__length1;
#line 128 "../app/FileStore.vala"
		_tmp1_ = deja_dup_file_tree_node_get_filename (child);
#line 128 "../app/FileStore.vala"
		_tmp2_ = _tmp1_;
#line 128 "../app/FileStore.vala"
		_tmp5_ = _tmp4_ = g_str_tokenize_and_fold (_tmp2_, "", &_tmp3_);
#line 128 "../app/FileStore.vala"
		ascii_tokens = (_vala_array_free (ascii_tokens, ascii_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 128 "../app/FileStore.vala"
		ascii_tokens = _tmp3_;
#line 128 "../app/FileStore.vala"
		ascii_tokens_length1 = -1;
#line 128 "../app/FileStore.vala"
		_ascii_tokens_size_ = ascii_tokens_length1;
#line 128 "../app/FileStore.vala"
		ascii_tokens_length1 = _vala_array_length (ascii_tokens);
#line 128 "../app/FileStore.vala"
		unicode_tokens = (_vala_array_free (unicode_tokens, unicode_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 128 "../app/FileStore.vala"
		unicode_tokens = _tmp5_;
#line 128 "../app/FileStore.vala"
		unicode_tokens_length1 = _vala_array_length (_tmp4_);
#line 128 "../app/FileStore.vala"
		_unicode_tokens_size_ = unicode_tokens_length1;
#line 129 "../app/FileStore.vala"
		_tmp6_ = unicode_tokens;
#line 129 "../app/FileStore.vala"
		_tmp6__length1 = unicode_tokens_length1;
#line 129 "../app/FileStore.vala"
		_tmp7_ = ascii_tokens;
#line 129 "../app/FileStore.vala"
		_tmp7__length1 = ascii_tokens_length1;
#line 129 "../app/FileStore.vala"
		_tmp8_ = g_new0 (gchar*, (_tmp6__length1 + _tmp7__length1) + 1);
#line 129 "../app/FileStore.vala"
		all_tokens = _tmp8_;
#line 129 "../app/FileStore.vala"
		all_tokens_length1 = _tmp6__length1 + _tmp7__length1;
#line 129 "../app/FileStore.vala"
		_all_tokens_size_ = all_tokens_length1;
#line 857 "FileStore.c"
		{
			gint i = 0;
#line 130 "../app/FileStore.vala"
			i = 0;
#line 862 "FileStore.c"
			{
				gboolean _tmp9_ = FALSE;
#line 130 "../app/FileStore.vala"
				_tmp9_ = TRUE;
#line 130 "../app/FileStore.vala"
				while (TRUE) {
#line 869 "FileStore.c"
					gchar** _tmp11_;
					gint _tmp11__length1;
					gchar** _tmp12_;
					gint _tmp12__length1;
					gchar** _tmp13_;
					gint _tmp13__length1;
					const gchar* _tmp14_;
					gchar* _tmp15_;
#line 130 "../app/FileStore.vala"
					if (!_tmp9_) {
#line 880 "FileStore.c"
						gint _tmp10_;
#line 130 "../app/FileStore.vala"
						_tmp10_ = i;
#line 130 "../app/FileStore.vala"
						i = _tmp10_ + 1;
#line 886 "FileStore.c"
					}
#line 130 "../app/FileStore.vala"
					_tmp9_ = FALSE;
#line 130 "../app/FileStore.vala"
					_tmp11_ = unicode_tokens;
#line 130 "../app/FileStore.vala"
					_tmp11__length1 = unicode_tokens_length1;
#line 130 "../app/FileStore.vala"
					if (!(i < _tmp11__length1)) {
#line 130 "../app/FileStore.vala"
						break;
#line 898 "FileStore.c"
					}
#line 131 "../app/FileStore.vala"
					_tmp12_ = all_tokens;
#line 131 "../app/FileStore.vala"
					_tmp12__length1 = all_tokens_length1;
#line 131 "../app/FileStore.vala"
					_tmp13_ = unicode_tokens;
#line 131 "../app/FileStore.vala"
					_tmp13__length1 = unicode_tokens_length1;
#line 131 "../app/FileStore.vala"
					_tmp14_ = _tmp13_[i];
#line 131 "../app/FileStore.vala"
					_tmp15_ = g_strdup (_tmp14_);
#line 131 "../app/FileStore.vala"
					_g_free0 (_tmp12_[i]);
#line 131 "../app/FileStore.vala"
					_tmp12_[i] = _tmp15_;
#line 916 "FileStore.c"
				}
			}
		}
		{
			gint i = 0;
#line 132 "../app/FileStore.vala"
			i = 0;
#line 924 "FileStore.c"
			{
				gboolean _tmp16_ = FALSE;
#line 132 "../app/FileStore.vala"
				_tmp16_ = TRUE;
#line 132 "../app/FileStore.vala"
				while (TRUE) {
#line 931 "FileStore.c"
					gchar** _tmp18_;
					gint _tmp18__length1;
					gchar** _tmp19_;
					gint _tmp19__length1;
					gchar** _tmp20_;
					gint _tmp20__length1;
					gchar** _tmp21_;
					gint _tmp21__length1;
					const gchar* _tmp22_;
					gchar* _tmp23_;
#line 132 "../app/FileStore.vala"
					if (!_tmp16_) {
#line 944 "FileStore.c"
						gint _tmp17_;
#line 132 "../app/FileStore.vala"
						_tmp17_ = i;
#line 132 "../app/FileStore.vala"
						i = _tmp17_ + 1;
#line 950 "FileStore.c"
					}
#line 132 "../app/FileStore.vala"
					_tmp16_ = FALSE;
#line 132 "../app/FileStore.vala"
					_tmp18_ = ascii_tokens;
#line 132 "../app/FileStore.vala"
					_tmp18__length1 = ascii_tokens_length1;
#line 132 "../app/FileStore.vala"
					if (!(i < _tmp18__length1)) {
#line 132 "../app/FileStore.vala"
						break;
#line 962 "FileStore.c"
					}
#line 133 "../app/FileStore.vala"
					_tmp19_ = all_tokens;
#line 133 "../app/FileStore.vala"
					_tmp19__length1 = all_tokens_length1;
#line 133 "../app/FileStore.vala"
					_tmp20_ = unicode_tokens;
#line 133 "../app/FileStore.vala"
					_tmp20__length1 = unicode_tokens_length1;
#line 133 "../app/FileStore.vala"
					_tmp21_ = ascii_tokens;
#line 133 "../app/FileStore.vala"
					_tmp21__length1 = ascii_tokens_length1;
#line 133 "../app/FileStore.vala"
					_tmp22_ = _tmp21_[i];
#line 133 "../app/FileStore.vala"
					_tmp23_ = g_strdup (_tmp22_);
#line 133 "../app/FileStore.vala"
					_g_free0 (_tmp19_[_tmp20__length1 + i]);
#line 133 "../app/FileStore.vala"
					_tmp19_[_tmp20__length1 + i] = _tmp23_;
#line 984 "FileStore.c"
				}
			}
		}
#line 134 "../app/FileStore.vala"
		_tmp24_ = all_tokens;
#line 134 "../app/FileStore.vala"
		_tmp24__length1 = all_tokens_length1;
#line 134 "../app/FileStore.vala"
		_tmp25_ = (_tmp24_ != NULL) ? _vala_array_dup1 (_tmp24_, _tmp24__length1) : _tmp24_;
#line 134 "../app/FileStore.vala"
		_tmp25__length1 = _tmp24__length1;
#line 134 "../app/FileStore.vala"
		child->search_tokens = (_vala_array_free (child->search_tokens, child->search_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 134 "../app/FileStore.vala"
		child->search_tokens = _tmp25_;
#line 134 "../app/FileStore.vala"
		child->search_tokens_length1 = _tmp25__length1;
#line 126 "../app/FileStore.vala"
		all_tokens = (_vala_array_free (all_tokens, all_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 126 "../app/FileStore.vala"
		ascii_tokens = (_vala_array_free (ascii_tokens, ascii_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 126 "../app/FileStore.vala"
		unicode_tokens = (_vala_array_free (unicode_tokens, unicode_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 1008 "FileStore.c"
	}
#line 137 "../app/FileStore.vala"
	all_matched = TRUE;
#line 1012 "FileStore.c"
	{
		gchar** needle_collection = NULL;
		gint needle_collection_length1 = 0;
		gint _needle_collection_size_ = 0;
		gint needle_it = 0;
#line 138 "../app/FileStore.vala"
		needle_collection = _data4_->needle_tokens;
#line 138 "../app/FileStore.vala"
		needle_collection_length1 = _data4_->needle_tokens_length1;
#line 138 "../app/FileStore.vala"
		for (needle_it = 0; needle_it < needle_collection_length1; needle_it = needle_it + 1) {
#line 1024 "FileStore.c"
			gchar* _tmp26_;
			gchar* needle = NULL;
#line 138 "../app/FileStore.vala"
			_tmp26_ = g_strdup (needle_collection[needle_it]);
#line 138 "../app/FileStore.vala"
			needle = _tmp26_;
#line 1031 "FileStore.c"
			{
				gboolean needle_matched = FALSE;
				gchar** _tmp27_;
				gint _tmp27__length1;
#line 139 "../app/FileStore.vala"
				needle_matched = FALSE;
#line 140 "../app/FileStore.vala"
				_tmp27_ = child->search_tokens;
#line 140 "../app/FileStore.vala"
				_tmp27__length1 = child->search_tokens_length1;
#line 1042 "FileStore.c"
				{
					gchar** token_collection = NULL;
					gint token_collection_length1 = 0;
					gint _token_collection_size_ = 0;
					gint token_it = 0;
#line 140 "../app/FileStore.vala"
					token_collection = _tmp27_;
#line 140 "../app/FileStore.vala"
					token_collection_length1 = _tmp27__length1;
#line 140 "../app/FileStore.vala"
					for (token_it = 0; token_it < token_collection_length1; token_it = token_it + 1) {
#line 1054 "FileStore.c"
						gchar* _tmp28_;
						gchar* token = NULL;
#line 140 "../app/FileStore.vala"
						_tmp28_ = g_strdup (token_collection[token_it]);
#line 140 "../app/FileStore.vala"
						token = _tmp28_;
#line 1061 "FileStore.c"
						{
							const gchar* _tmp29_;
							const gchar* _tmp30_;
#line 141 "../app/FileStore.vala"
							_tmp29_ = token;
#line 141 "../app/FileStore.vala"
							_tmp30_ = needle;
#line 141 "../app/FileStore.vala"
							if (string_contains (_tmp29_, _tmp30_)) {
#line 142 "../app/FileStore.vala"
								needle_matched = TRUE;
#line 143 "../app/FileStore.vala"
								_g_free0 (token);
#line 143 "../app/FileStore.vala"
								break;
#line 1077 "FileStore.c"
							}
#line 140 "../app/FileStore.vala"
							_g_free0 (token);
#line 1081 "FileStore.c"
						}
					}
				}
#line 146 "../app/FileStore.vala"
				if (!needle_matched) {
#line 147 "../app/FileStore.vala"
					all_matched = FALSE;
#line 148 "../app/FileStore.vala"
					_g_free0 (needle);
#line 148 "../app/FileStore.vala"
					break;
#line 1093 "FileStore.c"
				}
#line 138 "../app/FileStore.vala"
				_g_free0 (needle);
#line 1097 "FileStore.c"
			}
		}
	}
#line 152 "../app/FileStore.vala"
	if (all_matched) {
#line 153 "../app/FileStore.vala"
		file_store_insert_file (self, child);
#line 1105 "FileStore.c"
	}
#line 155 "../app/FileStore.vala"
	file_store_recursive_search (self, _data4_->needle_tokens, (gint) _data4_->needle_tokens_length1, child);
#line 1109 "FileStore.c"
}

static void
___lambda16__gh_func (gconstpointer key,
                      gconstpointer value,
                      gpointer self)
{
#line 124 "../app/FileStore.vala"
	__lambda16_ (self, (const gchar*) key, (DejaDupFileTreeNode*) value);
#line 1119 "FileStore.c"
}

static void
file_store_recursive_search (FileStore* self,
                             gchar** needle_tokens,
                             gint needle_tokens_length1,
                             DejaDupFileTreeNode* node)
{
	Block4Data* _data4_;
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
#line 122 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 122 "../app/FileStore.vala"
	g_return_if_fail (node != NULL);
#line 122 "../app/FileStore.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 122 "../app/FileStore.vala"
	_data4_->_ref_count_ = 1;
#line 122 "../app/FileStore.vala"
	_data4_->self = g_object_ref (self);
#line 122 "../app/FileStore.vala"
	_data4_->needle_tokens = needle_tokens;
#line 122 "../app/FileStore.vala"
	_data4_->needle_tokens_length1 = needle_tokens_length1;
#line 124 "../app/FileStore.vala"
	_tmp0_ = deja_dup_file_tree_node_get_children (node);
#line 124 "../app/FileStore.vala"
	_tmp1_ = _tmp0_;
#line 124 "../app/FileStore.vala"
	g_hash_table_foreach (_tmp1_, ___lambda16__gh_func, _data4_);
#line 122 "../app/FileStore.vala"
	block4_data_unref (_data4_);
#line 122 "../app/FileStore.vala"
	_data4_ = NULL;
#line 1155 "FileStore.c"
}

static void
__lambda14_ (FileStore* self,
             const gchar* name,
             DejaDupFileTreeNode* child)
{
#line 165 "../app/FileStore.vala"
	g_return_if_fail (name != NULL);
#line 165 "../app/FileStore.vala"
	g_return_if_fail (child != NULL);
#line 166 "../app/FileStore.vala"
	file_store_insert_file (self, child);
#line 1169 "FileStore.c"
}

static void
___lambda14__gh_func (gconstpointer key,
                      gconstpointer value,
                      gpointer self)
{
#line 165 "../app/FileStore.vala"
	__lambda14_ ((FileStore*) self, (const gchar*) key, (DejaDupFileTreeNode*) value);
#line 1179 "FileStore.c"
}

static void
file_store_set_current (FileStore* self,
                        DejaDupFileTreeNode* node)
{
	gint removed = 0;
	DejaDupFileTreeNode* _tmp0_;
	DejaDupFileTreeNode* _tmp1_;
	DejaDupFileTree* _tmp2_;
	DejaDupFileTreeNode* _tmp3_;
	DejaDupFileTreeNode* _tmp4_;
	DejaDupFileTreeNode* _tmp5_;
	GHashTable* _tmp6_;
	GHashTable* _tmp7_;
	GPtrArray* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
#line 159 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 159 "../app/FileStore.vala"
	g_return_if_fail (node != NULL);
#line 161 "../app/FileStore.vala"
	removed = file_store_clear_full (self);
#line 162 "../app/FileStore.vala"
	g_list_model_items_changed ((GListModel*) self, (guint) 0, (guint) removed, (guint) 0);
#line 163 "../app/FileStore.vala"
	_tmp0_ = _g_object_ref0 (node);
#line 163 "../app/FileStore.vala"
	_g_object_unref0 (self->priv->current);
#line 163 "../app/FileStore.vala"
	self->priv->current = _tmp0_;
#line 164 "../app/FileStore.vala"
	_tmp1_ = self->priv->current;
#line 164 "../app/FileStore.vala"
	_tmp2_ = self->priv->_tree;
#line 164 "../app/FileStore.vala"
	_tmp3_ = deja_dup_file_tree_get_root (_tmp2_);
#line 164 "../app/FileStore.vala"
	_tmp4_ = _tmp3_;
#line 164 "../app/FileStore.vala"
	file_store_set_can_go_up (self, _tmp1_ != _tmp4_);
#line 165 "../app/FileStore.vala"
	_tmp5_ = self->priv->current;
#line 165 "../app/FileStore.vala"
	_tmp6_ = deja_dup_file_tree_node_get_children (_tmp5_);
#line 165 "../app/FileStore.vala"
	_tmp7_ = _tmp6_;
#line 165 "../app/FileStore.vala"
	g_hash_table_foreach (_tmp7_, ___lambda14__gh_func, self);
#line 168 "../app/FileStore.vala"
	file_store_sort (self);
#line 169 "../app/FileStore.vala"
	_tmp8_ = self->priv->items;
#line 169 "../app/FileStore.vala"
	_tmp9_ = vala_g_ptr_array_get_length (_tmp8_);
#line 169 "../app/FileStore.vala"
	_tmp10_ = _tmp9_;
#line 169 "../app/FileStore.vala"
	g_list_model_items_changed ((GListModel*) self, (guint) 0, (guint) 0, (guint) _tmp10_);
#line 1240 "FileStore.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 5865 "glib-2.0.vapi"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 5865 "glib-2.0.vapi"
	return _data5_;
#line 1250 "FileStore.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 5865 "glib-2.0.vapi"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 1260 "FileStore.c"
		GPtrArray* self;
#line 5865 "glib-2.0.vapi"
		self = _data5_->self;
#line 5865 "glib-2.0.vapi"
		_g_ptr_array_unref0 (self);
#line 5865 "glib-2.0.vapi"
		g_slice_free (Block5Data, _data5_);
#line 1268 "FileStore.c"
	}
}

static gint
__lambda0_ (Block5Data* _data5_,
            gconstpointer** a,
            gconstpointer** b)
{
	GPtrArray* self;
	gint result;
#line 5866 "glib-2.0.vapi"
	self = _data5_->self;
#line 5867 "glib-2.0.vapi"
	result = _data5_->compare_func ((gconstpointer**) (*a), (gconstpointer**) (*b));
#line 5867 "glib-2.0.vapi"
	return result;
#line 1285 "FileStore.c"
}

static gint
___lambda0__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda0_ (self, a, b);
#line 5866 "glib-2.0.vapi"
	return result;
#line 1297 "FileStore.c"
}

static void
vala_g_ptr_array_sort (GPtrArray* self,
                       GCompareFunc compare_func)
{
	Block5Data* _data5_;
#line 5865 "glib-2.0.vapi"
	g_return_if_fail (self != NULL);
#line 5865 "glib-2.0.vapi"
	_data5_ = g_slice_new0 (Block5Data);
#line 5865 "glib-2.0.vapi"
	_data5_->_ref_count_ = 1;
#line 5865 "glib-2.0.vapi"
	_data5_->self = g_ptr_array_ref (self);
#line 5865 "glib-2.0.vapi"
	_data5_->compare_func = compare_func;
#line 5866 "glib-2.0.vapi"
	g_ptr_array_sort_with_data (self, ___lambda0__gcompare_data_func, _data5_);
#line 5865 "glib-2.0.vapi"
	block5_data_unref (_data5_);
#line 5865 "glib-2.0.vapi"
	_data5_ = NULL;
#line 1321 "FileStore.c"
}

static gint
__lambda15_ (FileStoreItem* a,
             FileStoreItem* b)
{
	GCompareFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint result;
#line 173 "../app/FileStore.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 173 "../app/FileStore.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 174 "../app/FileStore.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 174 "../app/FileStore.vala"
	_tmp1_ = file_store_item_get_collate_key (a);
#line 174 "../app/FileStore.vala"
	_tmp2_ = _tmp1_;
#line 174 "../app/FileStore.vala"
	_tmp3_ = file_store_item_get_collate_key (b);
#line 174 "../app/FileStore.vala"
	_tmp4_ = _tmp3_;
#line 174 "../app/FileStore.vala"
	result = _tmp0_ (_tmp2_, _tmp4_);
#line 174 "../app/FileStore.vala"
	return result;
#line 1352 "FileStore.c"
}

static gint
___lambda15__gcompare_func (gconstpointer a,
                            gconstpointer b)
{
	gint result;
	result = __lambda15_ ((FileStoreItem*) a, (FileStoreItem*) b);
#line 173 "../app/FileStore.vala"
	return result;
#line 1363 "FileStore.c"
}

static void
file_store_sort (FileStore* self)
{
	GPtrArray* _tmp0_;
#line 172 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 173 "../app/FileStore.vala"
	_tmp0_ = self->priv->items;
#line 173 "../app/FileStore.vala"
	vala_g_ptr_array_sort (_tmp0_, ___lambda15__gcompare_func);
#line 1376 "FileStore.c"
}

static void
file_store_insert_file (FileStore* self,
                        DejaDupFileTreeNode* node)
{
	const gchar* _tmp0_ = NULL;
	GFileType _tmp1_;
	GFileType _tmp2_;
	gchar* prefix = NULL;
	gchar* _tmp3_;
	gchar* key = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* collate_key = NULL;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_ = NULL;
	GFileType _tmp14_;
	GFileType _tmp15_;
	gchar* content_type = NULL;
	gchar* _tmp20_;
	GIcon* icon = NULL;
	const gchar* _tmp21_;
	GIcon* _tmp22_;
	GIcon* emblem = NULL;
	GFileType _tmp23_;
	GFileType _tmp24_;
	DejaDupFileTreeNode* iter = NULL;
	gchar* path = NULL;
	gchar* _tmp26_;
	GPtrArray* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	GIcon* _tmp53_;
	GIcon* _tmp54_;
	FileStoreItem* _tmp55_;
#line 178 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 178 "../app/FileStore.vala"
	g_return_if_fail (node != NULL);
#line 180 "../app/FileStore.vala"
	_tmp1_ = deja_dup_file_tree_node_get_kind (node);
#line 180 "../app/FileStore.vala"
	_tmp2_ = _tmp1_;
#line 180 "../app/FileStore.vala"
	if (_tmp2_ == G_FILE_TYPE_DIRECTORY) {
#line 180 "../app/FileStore.vala"
		_tmp0_ = "0:";
#line 1431 "FileStore.c"
	} else {
#line 180 "../app/FileStore.vala"
		_tmp0_ = "1:";
#line 1435 "FileStore.c"
	}
#line 180 "../app/FileStore.vala"
	_tmp3_ = g_strdup (_tmp0_);
#line 180 "../app/FileStore.vala"
	prefix = _tmp3_;
#line 181 "../app/FileStore.vala"
	_tmp4_ = deja_dup_file_tree_node_get_filename (node);
#line 181 "../app/FileStore.vala"
	_tmp5_ = _tmp4_;
#line 181 "../app/FileStore.vala"
	_tmp6_ = g_utf8_casefold (_tmp5_, (gssize) -1);
#line 181 "../app/FileStore.vala"
	_tmp7_ = _tmp6_;
#line 181 "../app/FileStore.vala"
	_tmp8_ = g_utf8_collate_key_for_filename (_tmp7_, (gssize) -1);
#line 181 "../app/FileStore.vala"
	_tmp9_ = _tmp8_;
#line 181 "../app/FileStore.vala"
	_g_free0 (_tmp7_);
#line 181 "../app/FileStore.vala"
	key = _tmp9_;
#line 182 "../app/FileStore.vala"
	_tmp10_ = prefix;
#line 182 "../app/FileStore.vala"
	_tmp11_ = key;
#line 182 "../app/FileStore.vala"
	_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
#line 182 "../app/FileStore.vala"
	collate_key = _tmp12_;
#line 185 "../app/FileStore.vala"
	_tmp14_ = deja_dup_file_tree_node_get_kind (node);
#line 185 "../app/FileStore.vala"
	_tmp15_ = _tmp14_;
#line 185 "../app/FileStore.vala"
	if (_tmp15_ == G_FILE_TYPE_DIRECTORY) {
#line 1471 "FileStore.c"
		gchar* _tmp16_;
#line 186 "../app/FileStore.vala"
		_tmp16_ = g_content_type_from_mime_type ("inode/directory");
#line 186 "../app/FileStore.vala"
		_g_free0 (_tmp13_);
#line 186 "../app/FileStore.vala"
		_tmp13_ = _tmp16_;
#line 1479 "FileStore.c"
	} else {
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
#line 187 "../app/FileStore.vala"
		_tmp17_ = deja_dup_file_tree_node_get_filename (node);
#line 187 "../app/FileStore.vala"
		_tmp18_ = _tmp17_;
#line 187 "../app/FileStore.vala"
		_tmp19_ = g_content_type_guess (_tmp18_, NULL, (gsize) 0, NULL);
#line 187 "../app/FileStore.vala"
		_g_free0 (_tmp13_);
#line 187 "../app/FileStore.vala"
		_tmp13_ = _tmp19_;
#line 1494 "FileStore.c"
	}
#line 185 "../app/FileStore.vala"
	_tmp20_ = g_strdup (_tmp13_);
#line 185 "../app/FileStore.vala"
	content_type = _tmp20_;
#line 188 "../app/FileStore.vala"
	_tmp21_ = content_type;
#line 188 "../app/FileStore.vala"
	_tmp22_ = g_content_type_get_icon (_tmp21_);
#line 188 "../app/FileStore.vala"
	icon = _tmp22_;
#line 190 "../app/FileStore.vala"
	emblem = NULL;
#line 191 "../app/FileStore.vala"
	_tmp23_ = deja_dup_file_tree_node_get_kind (node);
#line 191 "../app/FileStore.vala"
	_tmp24_ = _tmp23_;
#line 191 "../app/FileStore.vala"
	if (_tmp24_ == G_FILE_TYPE_SYMBOLIC_LINK) {
#line 1514 "FileStore.c"
		GThemedIcon* _tmp25_;
#line 192 "../app/FileStore.vala"
		_tmp25_ = (GThemedIcon*) g_themed_icon_new ("emblem-symbolic-link");
#line 192 "../app/FileStore.vala"
		_g_object_unref0 (emblem);
#line 192 "../app/FileStore.vala"
		emblem = (GIcon*) _tmp25_;
#line 1522 "FileStore.c"
	}
#line 196 "../app/FileStore.vala"
	iter = node;
#line 197 "../app/FileStore.vala"
	_tmp26_ = g_strdup ("");
#line 197 "../app/FileStore.vala"
	path = _tmp26_;
#line 198 "../app/FileStore.vala"
	while (TRUE) {
#line 1532 "FileStore.c"
		DejaDupFileTreeNode* _tmp27_;
		DejaDupFileTreeNode* _tmp28_;
		DejaDupFileTreeNode* _tmp29_;
		DejaDupFileTree* _tmp30_;
		DejaDupFileTreeNode* _tmp31_;
		DejaDupFileTreeNode* _tmp32_;
		const gchar* _tmp33_;
		DejaDupFileTreeNode* _tmp47_;
		DejaDupFileTreeNode* _tmp48_;
		DejaDupFileTreeNode* _tmp49_;
#line 198 "../app/FileStore.vala"
		_tmp27_ = iter;
#line 198 "../app/FileStore.vala"
		_tmp28_ = deja_dup_file_tree_node_get_parent (_tmp27_);
#line 198 "../app/FileStore.vala"
		_tmp29_ = _tmp28_;
#line 198 "../app/FileStore.vala"
		_tmp30_ = self->priv->_tree;
#line 198 "../app/FileStore.vala"
		_tmp31_ = deja_dup_file_tree_get_root (_tmp30_);
#line 198 "../app/FileStore.vala"
		_tmp32_ = _tmp31_;
#line 198 "../app/FileStore.vala"
		if (!(_tmp29_ != _tmp32_)) {
#line 198 "../app/FileStore.vala"
			break;
#line 1559 "FileStore.c"
		}
#line 199 "../app/FileStore.vala"
		_tmp33_ = path;
#line 199 "../app/FileStore.vala"
		if (g_strcmp0 (_tmp33_, "") == 0) {
#line 1565 "FileStore.c"
			DejaDupFileTreeNode* _tmp34_;
			DejaDupFileTreeNode* _tmp35_;
			DejaDupFileTreeNode* _tmp36_;
			const gchar* _tmp37_;
			const gchar* _tmp38_;
			gchar* _tmp39_;
#line 200 "../app/FileStore.vala"
			_tmp34_ = iter;
#line 200 "../app/FileStore.vala"
			_tmp35_ = deja_dup_file_tree_node_get_parent (_tmp34_);
#line 200 "../app/FileStore.vala"
			_tmp36_ = _tmp35_;
#line 200 "../app/FileStore.vala"
			_tmp37_ = deja_dup_file_tree_node_get_filename (_tmp36_);
#line 200 "../app/FileStore.vala"
			_tmp38_ = _tmp37_;
#line 200 "../app/FileStore.vala"
			_tmp39_ = g_strdup (_tmp38_);
#line 200 "../app/FileStore.vala"
			_g_free0 (path);
#line 200 "../app/FileStore.vala"
			path = _tmp39_;
#line 1588 "FileStore.c"
		} else {
			DejaDupFileTreeNode* _tmp40_;
			DejaDupFileTreeNode* _tmp41_;
			DejaDupFileTreeNode* _tmp42_;
			const gchar* _tmp43_;
			const gchar* _tmp44_;
			const gchar* _tmp45_;
			gchar* _tmp46_;
#line 202 "../app/FileStore.vala"
			_tmp40_ = iter;
#line 202 "../app/FileStore.vala"
			_tmp41_ = deja_dup_file_tree_node_get_parent (_tmp40_);
#line 202 "../app/FileStore.vala"
			_tmp42_ = _tmp41_;
#line 202 "../app/FileStore.vala"
			_tmp43_ = deja_dup_file_tree_node_get_filename (_tmp42_);
#line 202 "../app/FileStore.vala"
			_tmp44_ = _tmp43_;
#line 202 "../app/FileStore.vala"
			_tmp45_ = path;
#line 202 "../app/FileStore.vala"
			_tmp46_ = g_build_filename (_tmp44_, _tmp45_, NULL);
#line 202 "../app/FileStore.vala"
			_g_free0 (path);
#line 202 "../app/FileStore.vala"
			path = _tmp46_;
#line 1615 "FileStore.c"
		}
#line 203 "../app/FileStore.vala"
		_tmp47_ = iter;
#line 203 "../app/FileStore.vala"
		_tmp48_ = deja_dup_file_tree_node_get_parent (_tmp47_);
#line 203 "../app/FileStore.vala"
		_tmp49_ = _tmp48_;
#line 203 "../app/FileStore.vala"
		iter = _tmp49_;
#line 1625 "FileStore.c"
	}
#line 206 "../app/FileStore.vala"
	_tmp50_ = self->priv->items;
#line 206 "../app/FileStore.vala"
	_tmp51_ = collate_key;
#line 206 "../app/FileStore.vala"
	_tmp52_ = path;
#line 206 "../app/FileStore.vala"
	_tmp53_ = icon;
#line 206 "../app/FileStore.vala"
	_tmp54_ = emblem;
#line 206 "../app/FileStore.vala"
	_tmp55_ = file_store_item_new (node, _tmp51_, _tmp52_, _tmp53_, _tmp54_);
#line 206 "../app/FileStore.vala"
	g_ptr_array_add (_tmp50_, _tmp55_);
#line 178 "../app/FileStore.vala"
	_g_free0 (path);
#line 178 "../app/FileStore.vala"
	_g_object_unref0 (emblem);
#line 178 "../app/FileStore.vala"
	_g_object_unref0 (icon);
#line 178 "../app/FileStore.vala"
	_g_free0 (content_type);
#line 178 "../app/FileStore.vala"
	_g_free0 (_tmp13_);
#line 178 "../app/FileStore.vala"
	_g_free0 (collate_key);
#line 178 "../app/FileStore.vala"
	_g_free0 (key);
#line 178 "../app/FileStore.vala"
	_g_free0 (prefix);
#line 1657 "FileStore.c"
}

static void
file_store_handle_listed_files (FileStore* self,
                                DejaDupOperationFiles* op,
                                DejaDupFileTree* tree)
{
	DejaDupFileTreeNode* _tmp0_;
	DejaDupFileTreeNode* _tmp1_;
#line 209 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 209 "../app/FileStore.vala"
	g_return_if_fail (op != NULL);
#line 209 "../app/FileStore.vala"
	g_return_if_fail (tree != NULL);
#line 210 "../app/FileStore.vala"
	file_store_set_tree (self, tree);
#line 211 "../app/FileStore.vala"
	_tmp0_ = deja_dup_file_tree_get_root (tree);
#line 211 "../app/FileStore.vala"
	_tmp1_ = _tmp0_;
#line 211 "../app/FileStore.vala"
	file_store_set_current (self, _tmp1_);
#line 1681 "FileStore.c"
}

FileStore*
file_store_construct (GType object_type)
{
	FileStore * self = NULL;
#line 9 "../app/FileStore.vala"
	self = (FileStore*) g_object_new (object_type, NULL);
#line 9 "../app/FileStore.vala"
	return self;
#line 1692 "FileStore.c"
}

FileStore*
file_store_new (void)
{
#line 9 "../app/FileStore.vala"
	return file_store_construct (TYPE_FILE_STORE);
#line 1700 "FileStore.c"
}

DejaDupFileTree*
file_store_get_tree (FileStore* self)
{
	DejaDupFileTree* result;
	DejaDupFileTree* _tmp0_;
#line 11 "../app/FileStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 11 "../app/FileStore.vala"
	_tmp0_ = self->priv->_tree;
#line 11 "../app/FileStore.vala"
	result = _tmp0_;
#line 11 "../app/FileStore.vala"
	return result;
#line 1716 "FileStore.c"
}

static void
file_store_set_tree (FileStore* self,
                     DejaDupFileTree* value)
{
	DejaDupFileTree* old_value;
#line 11 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 11 "../app/FileStore.vala"
	old_value = file_store_get_tree (self);
#line 11 "../app/FileStore.vala"
	if (old_value != value) {
#line 1730 "FileStore.c"
		DejaDupFileTree* _tmp0_;
#line 11 "../app/FileStore.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 11 "../app/FileStore.vala"
		_g_object_unref0 (self->priv->_tree);
#line 11 "../app/FileStore.vala"
		self->priv->_tree = _tmp0_;
#line 11 "../app/FileStore.vala"
		g_object_notify_by_pspec ((GObject *) self, file_store_properties[FILE_STORE_TREE_PROPERTY]);
#line 1740 "FileStore.c"
	}
}

gboolean
file_store_get_can_go_up (FileStore* self)
{
	gboolean result;
#line 12 "../app/FileStore.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 12 "../app/FileStore.vala"
	result = self->priv->_can_go_up;
#line 12 "../app/FileStore.vala"
	return result;
#line 1754 "FileStore.c"
}

static void
file_store_set_can_go_up (FileStore* self,
                          gboolean value)
{
	gboolean old_value;
#line 12 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 12 "../app/FileStore.vala"
	old_value = file_store_get_can_go_up (self);
#line 12 "../app/FileStore.vala"
	if (old_value != value) {
#line 12 "../app/FileStore.vala"
		self->priv->_can_go_up = value;
#line 12 "../app/FileStore.vala"
		g_object_notify_by_pspec ((GObject *) self, file_store_properties[FILE_STORE_CAN_GO_UP_PROPERTY]);
#line 1772 "FileStore.c"
	}
}

const gchar*
file_store_get_search_filter (FileStore* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 13 "../app/FileStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 13 "../app/FileStore.vala"
	_tmp0_ = self->priv->_search_filter;
#line 13 "../app/FileStore.vala"
	result = _tmp0_;
#line 13 "../app/FileStore.vala"
	return result;
#line 1789 "FileStore.c"
}

void
file_store_set_search_filter (FileStore* self,
                              const gchar* value)
{
	gchar* old_value;
#line 13 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 13 "../app/FileStore.vala"
	old_value = file_store_get_search_filter (self);
#line 13 "../app/FileStore.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1803 "FileStore.c"
		gchar* _tmp0_;
#line 13 "../app/FileStore.vala"
		_tmp0_ = g_strdup (value);
#line 13 "../app/FileStore.vala"
		_g_free0 (self->priv->_search_filter);
#line 13 "../app/FileStore.vala"
		self->priv->_search_filter = _tmp0_;
#line 13 "../app/FileStore.vala"
		g_object_notify_by_pspec ((GObject *) self, file_store_properties[FILE_STORE_SEARCH_FILTER_PROPERTY]);
#line 1813 "FileStore.c"
	}
}

static inline gpointer
file_store_item_get_instance_private (FileStoreItem* self)
{
	return G_STRUCT_MEMBER_P (self, FileStoreItem_private_offset);
}

FileStoreItem*
file_store_item_construct (GType object_type,
                           DejaDupFileTreeNode* node,
                           const gchar* collate_key,
                           const gchar* path,
                           GIcon* icon,
                           GIcon* emblem)
{
	FileStoreItem * self = NULL;
#line 75 "../app/FileStore.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 75 "../app/FileStore.vala"
	g_return_val_if_fail (collate_key != NULL, NULL);
#line 75 "../app/FileStore.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 78 "../app/FileStore.vala"
	self = (FileStoreItem*) g_object_new (object_type, "node", node, "collate-key", collate_key, "path", path, "icon", icon, "emblem", emblem, NULL);
#line 75 "../app/FileStore.vala"
	return self;
#line 1842 "FileStore.c"
}

FileStoreItem*
file_store_item_new (DejaDupFileTreeNode* node,
                     const gchar* collate_key,
                     const gchar* path,
                     GIcon* icon,
                     GIcon* emblem)
{
#line 75 "../app/FileStore.vala"
	return file_store_item_construct (FILE_STORE_TYPE_ITEM, node, collate_key, path, icon, emblem);
#line 1854 "FileStore.c"
}

DejaDupFileTreeNode*
file_store_item_get_node (FileStoreItem* self)
{
	DejaDupFileTreeNode* result;
	DejaDupFileTreeNode* _tmp0_;
#line 68 "../app/FileStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "../app/FileStore.vala"
	_tmp0_ = self->priv->_node;
#line 68 "../app/FileStore.vala"
	result = _tmp0_;
#line 68 "../app/FileStore.vala"
	return result;
#line 1870 "FileStore.c"
}

static void
file_store_item_set_node (FileStoreItem* self,
                          DejaDupFileTreeNode* value)
{
	DejaDupFileTreeNode* old_value;
#line 68 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 68 "../app/FileStore.vala"
	old_value = file_store_item_get_node (self);
#line 68 "../app/FileStore.vala"
	if (old_value != value) {
#line 1884 "FileStore.c"
		DejaDupFileTreeNode* _tmp0_;
#line 68 "../app/FileStore.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 68 "../app/FileStore.vala"
		_g_object_unref0 (self->priv->_node);
#line 68 "../app/FileStore.vala"
		self->priv->_node = _tmp0_;
#line 68 "../app/FileStore.vala"
		g_object_notify_by_pspec ((GObject *) self, file_store_item_properties[FILE_STORE_ITEM_NODE_PROPERTY]);
#line 1894 "FileStore.c"
	}
}

const gchar*
file_store_item_get_filename (FileStoreItem* self)
{
	const gchar* result;
	DejaDupFileTreeNode* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 69 "../app/FileStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "../app/FileStore.vala"
	_tmp0_ = self->priv->_node;
#line 69 "../app/FileStore.vala"
	_tmp1_ = deja_dup_file_tree_node_get_filename (_tmp0_);
#line 69 "../app/FileStore.vala"
	_tmp2_ = _tmp1_;
#line 69 "../app/FileStore.vala"
	result = _tmp2_;
#line 69 "../app/FileStore.vala"
	return result;
#line 1917 "FileStore.c"
}

const gchar*
file_store_item_get_collate_key (FileStoreItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 70 "../app/FileStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "../app/FileStore.vala"
	_tmp0_ = self->priv->_collate_key;
#line 70 "../app/FileStore.vala"
	result = _tmp0_;
#line 70 "../app/FileStore.vala"
	return result;
#line 1933 "FileStore.c"
}

static void
file_store_item_set_collate_key (FileStoreItem* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 70 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 70 "../app/FileStore.vala"
	old_value = file_store_item_get_collate_key (self);
#line 70 "../app/FileStore.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1947 "FileStore.c"
		gchar* _tmp0_;
#line 70 "../app/FileStore.vala"
		_tmp0_ = g_strdup (value);
#line 70 "../app/FileStore.vala"
		_g_free0 (self->priv->_collate_key);
#line 70 "../app/FileStore.vala"
		self->priv->_collate_key = _tmp0_;
#line 70 "../app/FileStore.vala"
		g_object_notify_by_pspec ((GObject *) self, file_store_item_properties[FILE_STORE_ITEM_COLLATE_KEY_PROPERTY]);
#line 1957 "FileStore.c"
	}
}

const gchar*
file_store_item_get_path (FileStoreItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 71 "../app/FileStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../app/FileStore.vala"
	_tmp0_ = self->priv->_path;
#line 71 "../app/FileStore.vala"
	result = _tmp0_;
#line 71 "../app/FileStore.vala"
	return result;
#line 1974 "FileStore.c"
}

static void
file_store_item_set_path (FileStoreItem* self,
                          const gchar* value)
{
	gchar* old_value;
#line 71 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 71 "../app/FileStore.vala"
	old_value = file_store_item_get_path (self);
#line 71 "../app/FileStore.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1988 "FileStore.c"
		gchar* _tmp0_;
#line 71 "../app/FileStore.vala"
		_tmp0_ = g_strdup (value);
#line 71 "../app/FileStore.vala"
		_g_free0 (self->priv->_path);
#line 71 "../app/FileStore.vala"
		self->priv->_path = _tmp0_;
#line 71 "../app/FileStore.vala"
		g_object_notify_by_pspec ((GObject *) self, file_store_item_properties[FILE_STORE_ITEM_PATH_PROPERTY]);
#line 1998 "FileStore.c"
	}
}

GIcon*
file_store_item_get_icon (FileStoreItem* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 72 "../app/FileStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../app/FileStore.vala"
	_tmp0_ = self->priv->_icon;
#line 72 "../app/FileStore.vala"
	result = _tmp0_;
#line 72 "../app/FileStore.vala"
	return result;
#line 2015 "FileStore.c"
}

static void
file_store_item_set_icon (FileStoreItem* self,
                          GIcon* value)
{
	GIcon* old_value;
#line 72 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 72 "../app/FileStore.vala"
	old_value = file_store_item_get_icon (self);
#line 72 "../app/FileStore.vala"
	if (old_value != value) {
#line 2029 "FileStore.c"
		GIcon* _tmp0_;
#line 72 "../app/FileStore.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 72 "../app/FileStore.vala"
		_g_object_unref0 (self->priv->_icon);
#line 72 "../app/FileStore.vala"
		self->priv->_icon = _tmp0_;
#line 72 "../app/FileStore.vala"
		g_object_notify_by_pspec ((GObject *) self, file_store_item_properties[FILE_STORE_ITEM_ICON_PROPERTY]);
#line 2039 "FileStore.c"
	}
}

GIcon*
file_store_item_get_emblem (FileStoreItem* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 73 "../app/FileStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../app/FileStore.vala"
	_tmp0_ = self->priv->_emblem;
#line 73 "../app/FileStore.vala"
	result = _tmp0_;
#line 73 "../app/FileStore.vala"
	return result;
#line 2056 "FileStore.c"
}

static void
file_store_item_set_emblem (FileStoreItem* self,
                            GIcon* value)
{
	GIcon* old_value;
#line 73 "../app/FileStore.vala"
	g_return_if_fail (self != NULL);
#line 73 "../app/FileStore.vala"
	old_value = file_store_item_get_emblem (self);
#line 73 "../app/FileStore.vala"
	if (old_value != value) {
#line 2070 "FileStore.c"
		GIcon* _tmp0_;
#line 73 "../app/FileStore.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 73 "../app/FileStore.vala"
		_g_object_unref0 (self->priv->_emblem);
#line 73 "../app/FileStore.vala"
		self->priv->_emblem = _tmp0_;
#line 73 "../app/FileStore.vala"
		g_object_notify_by_pspec ((GObject *) self, file_store_item_properties[FILE_STORE_ITEM_EMBLEM_PROPERTY]);
#line 2080 "FileStore.c"
	}
}

static void
file_store_item_class_init (FileStoreItemClass * klass,
                            gpointer klass_data)
{
#line 67 "../app/FileStore.vala"
	file_store_item_parent_class = g_type_class_peek_parent (klass);
#line 67 "../app/FileStore.vala"
	g_type_class_adjust_private_offset (klass, &FileStoreItem_private_offset);
#line 67 "../app/FileStore.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_file_store_item_get_property;
#line 67 "../app/FileStore.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_file_store_item_set_property;
#line 67 "../app/FileStore.vala"
	G_OBJECT_CLASS (klass)->finalize = file_store_item_finalize;
#line 67 "../app/FileStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_STORE_ITEM_NODE_PROPERTY, file_store_item_properties[FILE_STORE_ITEM_NODE_PROPERTY] = g_param_spec_object ("node", "node", "node", DEJA_DUP_FILE_TREE_TYPE_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 67 "../app/FileStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_STORE_ITEM_FILENAME_PROPERTY, file_store_item_properties[FILE_STORE_ITEM_FILENAME_PROPERTY] = g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 67 "../app/FileStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_STORE_ITEM_COLLATE_KEY_PROPERTY, file_store_item_properties[FILE_STORE_ITEM_COLLATE_KEY_PROPERTY] = g_param_spec_string ("collate-key", "collate-key", "collate-key", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 67 "../app/FileStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_STORE_ITEM_PATH_PROPERTY, file_store_item_properties[FILE_STORE_ITEM_PATH_PROPERTY] = g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 67 "../app/FileStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_STORE_ITEM_ICON_PROPERTY, file_store_item_properties[FILE_STORE_ITEM_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 67 "../app/FileStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_STORE_ITEM_EMBLEM_PROPERTY, file_store_item_properties[FILE_STORE_ITEM_EMBLEM_PROPERTY] = g_param_spec_object ("emblem", "emblem", "emblem", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2110 "FileStore.c"
}

static void
file_store_item_instance_init (FileStoreItem * self,
                               gpointer klass)
{
#line 67 "../app/FileStore.vala"
	self->priv = file_store_item_get_instance_private (self);
#line 2119 "FileStore.c"
}

static void
file_store_item_finalize (GObject * obj)
{
	FileStoreItem * self;
#line 67 "../app/FileStore.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILE_STORE_TYPE_ITEM, FileStoreItem);
#line 68 "../app/FileStore.vala"
	_g_object_unref0 (self->priv->_node);
#line 70 "../app/FileStore.vala"
	_g_free0 (self->priv->_collate_key);
#line 71 "../app/FileStore.vala"
	_g_free0 (self->priv->_path);
#line 72 "../app/FileStore.vala"
	_g_object_unref0 (self->priv->_icon);
#line 73 "../app/FileStore.vala"
	_g_object_unref0 (self->priv->_emblem);
#line 67 "../app/FileStore.vala"
	G_OBJECT_CLASS (file_store_item_parent_class)->finalize (obj);
#line 2140 "FileStore.c"
}

 G_GNUC_NO_INLINE static GType
file_store_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FileStoreItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_store_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FileStoreItem), 0, (GInstanceInitFunc) file_store_item_instance_init, NULL };
	GType file_store_item_type_id;
	file_store_item_type_id = g_type_register_static (G_TYPE_OBJECT, "FileStoreItem", &g_define_type_info, 0);
	FileStoreItem_private_offset = g_type_add_instance_private (file_store_item_type_id, sizeof (FileStoreItemPrivate));
	return file_store_item_type_id;
}

GType
file_store_item_get_type (void)
{
	static gsize file_store_item_type_id__once = 0;
	if (g_once_init_enter (&file_store_item_type_id__once)) {
		GType file_store_item_type_id;
		file_store_item_type_id = file_store_item_get_type_once ();
		g_once_init_leave (&file_store_item_type_id__once, file_store_item_type_id);
	}
	return file_store_item_type_id__once;
}

static void
_vala_file_store_item_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	FileStoreItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FILE_STORE_TYPE_ITEM, FileStoreItem);
#line 67 "../app/FileStore.vala"
	switch (property_id) {
#line 67 "../app/FileStore.vala"
		case FILE_STORE_ITEM_NODE_PROPERTY:
#line 67 "../app/FileStore.vala"
		g_value_set_object (value, file_store_item_get_node (self));
#line 67 "../app/FileStore.vala"
		break;
#line 67 "../app/FileStore.vala"
		case FILE_STORE_ITEM_FILENAME_PROPERTY:
#line 67 "../app/FileStore.vala"
		g_value_set_string (value, file_store_item_get_filename (self));
#line 67 "../app/FileStore.vala"
		break;
#line 67 "../app/FileStore.vala"
		case FILE_STORE_ITEM_COLLATE_KEY_PROPERTY:
#line 67 "../app/FileStore.vala"
		g_value_set_string (value, file_store_item_get_collate_key (self));
#line 67 "../app/FileStore.vala"
		break;
#line 67 "../app/FileStore.vala"
		case FILE_STORE_ITEM_PATH_PROPERTY:
#line 67 "../app/FileStore.vala"
		g_value_set_string (value, file_store_item_get_path (self));
#line 67 "../app/FileStore.vala"
		break;
#line 67 "../app/FileStore.vala"
		case FILE_STORE_ITEM_ICON_PROPERTY:
#line 67 "../app/FileStore.vala"
		g_value_set_object (value, file_store_item_get_icon (self));
#line 67 "../app/FileStore.vala"
		break;
#line 67 "../app/FileStore.vala"
		case FILE_STORE_ITEM_EMBLEM_PROPERTY:
#line 67 "../app/FileStore.vala"
		g_value_set_object (value, file_store_item_get_emblem (self));
#line 67 "../app/FileStore.vala"
		break;
#line 2211 "FileStore.c"
		default:
#line 67 "../app/FileStore.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 67 "../app/FileStore.vala"
		break;
#line 2217 "FileStore.c"
	}
}

static void
_vala_file_store_item_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	FileStoreItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FILE_STORE_TYPE_ITEM, FileStoreItem);
#line 67 "../app/FileStore.vala"
	switch (property_id) {
#line 67 "../app/FileStore.vala"
		case FILE_STORE_ITEM_NODE_PROPERTY:
#line 67 "../app/FileStore.vala"
		file_store_item_set_node (self, g_value_get_object (value));
#line 67 "../app/FileStore.vala"
		break;
#line 67 "../app/FileStore.vala"
		case FILE_STORE_ITEM_COLLATE_KEY_PROPERTY:
#line 67 "../app/FileStore.vala"
		file_store_item_set_collate_key (self, g_value_get_string (value));
#line 67 "../app/FileStore.vala"
		break;
#line 67 "../app/FileStore.vala"
		case FILE_STORE_ITEM_PATH_PROPERTY:
#line 67 "../app/FileStore.vala"
		file_store_item_set_path (self, g_value_get_string (value));
#line 67 "../app/FileStore.vala"
		break;
#line 67 "../app/FileStore.vala"
		case FILE_STORE_ITEM_ICON_PROPERTY:
#line 67 "../app/FileStore.vala"
		file_store_item_set_icon (self, g_value_get_object (value));
#line 67 "../app/FileStore.vala"
		break;
#line 67 "../app/FileStore.vala"
		case FILE_STORE_ITEM_EMBLEM_PROPERTY:
#line 67 "../app/FileStore.vala"
		file_store_item_set_emblem (self, g_value_get_object (value));
#line 67 "../app/FileStore.vala"
		break;
#line 2261 "FileStore.c"
		default:
#line 67 "../app/FileStore.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 67 "../app/FileStore.vala"
		break;
#line 2267 "FileStore.c"
	}
}

static void
_g_object_unref0_ (gpointer var)
{
#line 89 "../app/FileStore.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2276 "FileStore.c"
}

static void
_file_store_update_search_g_object_notify (GObject* _sender,
                                           GParamSpec* pspec,
                                           gpointer self)
{
#line 91 "../app/FileStore.vala"
	file_store_update_search ((FileStore*) self);
#line 2286 "FileStore.c"
}

static GObject *
file_store_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FileStore * self;
	GPtrArray* _tmp0_;
#line 88 "../app/FileStore.vala"
	parent_class = G_OBJECT_CLASS (file_store_parent_class);
#line 88 "../app/FileStore.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 88 "../app/FileStore.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILE_STORE, FileStore);
#line 89 "../app/FileStore.vala"
	_tmp0_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 89 "../app/FileStore.vala"
	_g_ptr_array_unref0 (self->priv->items);
#line 89 "../app/FileStore.vala"
	self->priv->items = _tmp0_;
#line 91 "../app/FileStore.vala"
	g_signal_connect_object ((GObject*) self, "notify::search-filter", (GCallback) _file_store_update_search_g_object_notify, self, 0);
#line 88 "../app/FileStore.vala"
	return obj;
#line 2314 "FileStore.c"
}

static void
file_store_class_init (FileStoreClass * klass,
                       gpointer klass_data)
{
#line 9 "../app/FileStore.vala"
	file_store_parent_class = g_type_class_peek_parent (klass);
#line 9 "../app/FileStore.vala"
	g_type_class_adjust_private_offset (klass, &FileStore_private_offset);
#line 9 "../app/FileStore.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_file_store_get_property;
#line 9 "../app/FileStore.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_file_store_set_property;
#line 9 "../app/FileStore.vala"
	G_OBJECT_CLASS (klass)->constructor = file_store_constructor;
#line 9 "../app/FileStore.vala"
	G_OBJECT_CLASS (klass)->finalize = file_store_finalize;
#line 9 "../app/FileStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_STORE_TREE_PROPERTY, file_store_properties[FILE_STORE_TREE_PROPERTY] = g_param_spec_object ("tree", "tree", "tree", DEJA_DUP_TYPE_FILE_TREE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9 "../app/FileStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_STORE_CAN_GO_UP_PROPERTY, file_store_properties[FILE_STORE_CAN_GO_UP_PROPERTY] = g_param_spec_boolean ("can-go-up", "can-go-up", "can-go-up", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9 "../app/FileStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_STORE_SEARCH_FILTER_PROPERTY, file_store_properties[FILE_STORE_SEARCH_FILTER_PROPERTY] = g_param_spec_string ("search-filter", "search-filter", "search-filter", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2339 "FileStore.c"
}

static void
file_store_g_list_model_interface_init (GListModelInterface * iface,
                                        gpointer iface_data)
{
#line 9 "../app/FileStore.vala"
	file_store_g_list_model_parent_iface = g_type_interface_peek_parent (iface);
#line 9 "../app/FileStore.vala"
	iface->get_item_type = (GType (*) (GListModel*)) file_store_real_get_item_type;
#line 9 "../app/FileStore.vala"
	iface->get_n_items = (guint (*) (GListModel*)) file_store_real_get_n_items;
#line 9 "../app/FileStore.vala"
	iface->get_item = (GObject* (*) (GListModel*, guint)) file_store_real_get_item;
#line 2354 "FileStore.c"
}

static void
file_store_instance_init (FileStore * self,
                          gpointer klass)
{
#line 9 "../app/FileStore.vala"
	self->priv = file_store_get_instance_private (self);
#line 11 "../app/FileStore.vala"
	self->priv->_tree = NULL;
#line 12 "../app/FileStore.vala"
	self->priv->_can_go_up = FALSE;
#line 13 "../app/FileStore.vala"
	self->priv->_search_filter = NULL;
#line 2369 "FileStore.c"
}

static void
file_store_finalize (GObject * obj)
{
	FileStore * self;
#line 9 "../app/FileStore.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILE_STORE, FileStore);
#line 11 "../app/FileStore.vala"
	_g_object_unref0 (self->priv->_tree);
#line 13 "../app/FileStore.vala"
	_g_free0 (self->priv->_search_filter);
#line 85 "../app/FileStore.vala"
	_g_object_unref0 (self->priv->current);
#line 86 "../app/FileStore.vala"
	_g_ptr_array_unref0 (self->priv->items);
#line 9 "../app/FileStore.vala"
	G_OBJECT_CLASS (file_store_parent_class)->finalize (obj);
#line 2388 "FileStore.c"
}

 G_GNUC_NO_INLINE static GType
file_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FileStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FileStore), 0, (GInstanceInitFunc) file_store_instance_init, NULL };
	static const GInterfaceInfo g_list_model_info = { (GInterfaceInitFunc) file_store_g_list_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType file_store_type_id;
	file_store_type_id = g_type_register_static (G_TYPE_OBJECT, "FileStore", &g_define_type_info, 0);
	g_type_add_interface_static (file_store_type_id, g_list_model_get_type (), &g_list_model_info);
	FileStore_private_offset = g_type_add_instance_private (file_store_type_id, sizeof (FileStorePrivate));
	return file_store_type_id;
}

GType
file_store_get_type (void)
{
	static gsize file_store_type_id__once = 0;
	if (g_once_init_enter (&file_store_type_id__once)) {
		GType file_store_type_id;
		file_store_type_id = file_store_get_type_once ();
		g_once_init_leave (&file_store_type_id__once, file_store_type_id);
	}
	return file_store_type_id__once;
}

static void
_vala_file_store_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	FileStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILE_STORE, FileStore);
#line 9 "../app/FileStore.vala"
	switch (property_id) {
#line 9 "../app/FileStore.vala"
		case FILE_STORE_TREE_PROPERTY:
#line 9 "../app/FileStore.vala"
		g_value_set_object (value, file_store_get_tree (self));
#line 9 "../app/FileStore.vala"
		break;
#line 9 "../app/FileStore.vala"
		case FILE_STORE_CAN_GO_UP_PROPERTY:
#line 9 "../app/FileStore.vala"
		g_value_set_boolean (value, file_store_get_can_go_up (self));
#line 9 "../app/FileStore.vala"
		break;
#line 9 "../app/FileStore.vala"
		case FILE_STORE_SEARCH_FILTER_PROPERTY:
#line 9 "../app/FileStore.vala"
		g_value_set_string (value, file_store_get_search_filter (self));
#line 9 "../app/FileStore.vala"
		break;
#line 2443 "FileStore.c"
		default:
#line 9 "../app/FileStore.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../app/FileStore.vala"
		break;
#line 2449 "FileStore.c"
	}
}

static void
_vala_file_store_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	FileStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILE_STORE, FileStore);
#line 9 "../app/FileStore.vala"
	switch (property_id) {
#line 9 "../app/FileStore.vala"
		case FILE_STORE_TREE_PROPERTY:
#line 9 "../app/FileStore.vala"
		file_store_set_tree (self, g_value_get_object (value));
#line 9 "../app/FileStore.vala"
		break;
#line 9 "../app/FileStore.vala"
		case FILE_STORE_CAN_GO_UP_PROPERTY:
#line 9 "../app/FileStore.vala"
		file_store_set_can_go_up (self, g_value_get_boolean (value));
#line 9 "../app/FileStore.vala"
		break;
#line 9 "../app/FileStore.vala"
		case FILE_STORE_SEARCH_FILTER_PROPERTY:
#line 9 "../app/FileStore.vala"
		file_store_set_search_filter (self, g_value_get_string (value));
#line 9 "../app/FileStore.vala"
		break;
#line 2481 "FileStore.c"
		default:
#line 9 "../app/FileStore.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../app/FileStore.vala"
		break;
#line 2487 "FileStore.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

