/* Notifications.c generated by valac 0.56.13, the Vala compiler
 * generated from Notifications.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Michael Terry
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include "deja.h"

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_NOTIFICATIONS (notifications_get_type ())
#define NOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATIONS, Notifications))
#define NOTIFICATIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATIONS, NotificationsClass))
#define IS_NOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATIONS))
#define IS_NOTIFICATIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATIONS))
#define NOTIFICATIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATIONS, NotificationsClass))

typedef struct _Notifications Notifications;
typedef struct _NotificationsClass NotificationsClass;
typedef struct _NotificationsPrivate NotificationsPrivate;
enum  {
	NOTIFICATIONS_0_PROPERTY,
	NOTIFICATIONS_NUM_PROPERTIES
};
static GParamSpec* notifications_properties[NOTIFICATIONS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Notifications {
	GObject parent_instance;
	NotificationsPrivate * priv;
};

struct _NotificationsClass {
	GObjectClass parent_class;
};

static gpointer notifications_parent_class = NULL;

VALA_EXTERN GType notifications_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Notifications, g_object_unref)
VALA_EXTERN void notifications_automatic_backup_started (void);
static void notifications_send_status (const gchar* title,
                                const gchar* body,
                                GNotificationPriority priority);
VALA_EXTERN void notifications_automatic_backup_delayed (const gchar* reason);
VALA_EXTERN void notifications_backup_finished (GtkWindow* win,
                                    gboolean success,
                                    gboolean cancelled,
                                    const gchar* detail);
static gboolean notifications_window_is_active (GtkWindow* win);
static void notifications_withdraw_status (void);
VALA_EXTERN void notifications_restore_finished (GtkWindow* win,
                                     gboolean success,
                                     gboolean cancelled,
                                     const gchar* detail);
VALA_EXTERN void notifications_operation_blocked (GtkWindow* win,
                                      const gchar* title,
                                      const gchar* body);
VALA_EXTERN void notifications_operation_unblocked (void);
VALA_EXTERN void notifications_attention_needed (GtkWindow* win,
                                     const gchar* title,
                                     const gchar* body);
VALA_EXTERN void notifications_prompt (void);
static GNotification* notifications_make_note (const gchar* title,
                                        const gchar* body);
VALA_EXTERN void notifications_close_all (void);
VALA_EXTERN Notifications* notifications_new (void);
VALA_EXTERN Notifications* notifications_construct (GType object_type);
static GType notifications_get_type_once (void);

void
notifications_automatic_backup_started (void)
{
#line 13 "../app/Notifications.vala"
	notifications_send_status (_ ("Starting scheduled backup"), NULL, G_NOTIFICATION_PRIORITY_LOW);
#line 96 "Notifications.c"
}

void
notifications_automatic_backup_delayed (const gchar* reason)
{
#line 16 "../app/Notifications.vala"
	g_return_if_fail (reason != NULL);
#line 18 "../app/Notifications.vala"
	notifications_send_status (_ ("Scheduled backup delayed"), reason, G_NOTIFICATION_PRIORITY_NORMAL);
#line 106 "Notifications.c"
}

void
notifications_backup_finished (GtkWindow* win,
                               gboolean success,
                               gboolean cancelled,
                               const gchar* detail)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 21 "../app/Notifications.vala"
	g_return_if_fail (win != NULL);
#line 24 "../app/Notifications.vala"
	if (!notifications_window_is_active (win)) {
#line 24 "../app/Notifications.vala"
		_tmp1_ = success;
#line 123 "Notifications.c"
	} else {
#line 24 "../app/Notifications.vala"
		_tmp1_ = FALSE;
#line 127 "Notifications.c"
	}
#line 24 "../app/Notifications.vala"
	if (_tmp1_) {
#line 24 "../app/Notifications.vala"
		_tmp0_ = !cancelled;
#line 133 "Notifications.c"
	} else {
#line 24 "../app/Notifications.vala"
		_tmp0_ = FALSE;
#line 137 "Notifications.c"
	}
#line 24 "../app/Notifications.vala"
	if (_tmp0_) {
#line 141 "Notifications.c"
		gchar* title = NULL;
		gchar* _tmp2_;
		GNotificationPriority priority = 0;
		gchar* body = NULL;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 25 "../app/Notifications.vala"
		_tmp2_ = g_strdup (_ ("Backup completed"));
#line 25 "../app/Notifications.vala"
		title = _tmp2_;
#line 26 "../app/Notifications.vala"
		priority = G_NOTIFICATION_PRIORITY_LOW;
#line 28 "../app/Notifications.vala"
		body = NULL;
#line 29 "../app/Notifications.vala"
		if (detail != NULL) {
#line 158 "Notifications.c"
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 30 "../app/Notifications.vala"
			_tmp3_ = g_strdup (_ ("Backup finished"));
#line 30 "../app/Notifications.vala"
			_g_free0 (title);
#line 30 "../app/Notifications.vala"
			title = _tmp3_;
#line 31 "../app/Notifications.vala"
			_tmp4_ = g_strdup (_ ("But not all files were successfully backed up."));
#line 31 "../app/Notifications.vala"
			_g_free0 (body);
#line 31 "../app/Notifications.vala"
			body = _tmp4_;
#line 32 "../app/Notifications.vala"
			priority = G_NOTIFICATION_PRIORITY_NORMAL;
#line 175 "Notifications.c"
		}
#line 35 "../app/Notifications.vala"
		_tmp5_ = title;
#line 35 "../app/Notifications.vala"
		_tmp6_ = body;
#line 35 "../app/Notifications.vala"
		notifications_send_status (_tmp5_, _tmp6_, priority);
#line 24 "../app/Notifications.vala"
		_g_free0 (body);
#line 24 "../app/Notifications.vala"
		_g_free0 (title);
#line 187 "Notifications.c"
	} else {
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
#line 37 "../app/Notifications.vala"
		if (!notifications_window_is_active (win)) {
#line 37 "../app/Notifications.vala"
			_tmp8_ = !success;
#line 195 "Notifications.c"
		} else {
#line 37 "../app/Notifications.vala"
			_tmp8_ = FALSE;
#line 199 "Notifications.c"
		}
#line 37 "../app/Notifications.vala"
		if (_tmp8_) {
#line 37 "../app/Notifications.vala"
			_tmp7_ = !cancelled;
#line 205 "Notifications.c"
		} else {
#line 37 "../app/Notifications.vala"
			_tmp7_ = FALSE;
#line 209 "Notifications.c"
		}
#line 37 "../app/Notifications.vala"
		if (_tmp7_) {
#line 38 "../app/Notifications.vala"
			notifications_send_status (_ ("Backup failed"), NULL, G_NOTIFICATION_PRIORITY_NORMAL);
#line 215 "Notifications.c"
		} else {
#line 42 "../app/Notifications.vala"
			notifications_withdraw_status ();
#line 219 "Notifications.c"
		}
	}
}

void
notifications_restore_finished (GtkWindow* win,
                                gboolean success,
                                gboolean cancelled,
                                const gchar* detail)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 46 "../app/Notifications.vala"
	g_return_if_fail (win != NULL);
#line 49 "../app/Notifications.vala"
	if (!notifications_window_is_active (win)) {
#line 49 "../app/Notifications.vala"
		_tmp1_ = !success;
#line 238 "Notifications.c"
	} else {
#line 49 "../app/Notifications.vala"
		_tmp1_ = FALSE;
#line 242 "Notifications.c"
	}
#line 49 "../app/Notifications.vala"
	if (_tmp1_) {
#line 49 "../app/Notifications.vala"
		_tmp0_ = !cancelled;
#line 248 "Notifications.c"
	} else {
#line 49 "../app/Notifications.vala"
		_tmp0_ = FALSE;
#line 252 "Notifications.c"
	}
#line 49 "../app/Notifications.vala"
	if (_tmp0_) {
#line 50 "../app/Notifications.vala"
		notifications_send_status (_ ("Restore failed"), NULL, G_NOTIFICATION_PRIORITY_NORMAL);
#line 258 "Notifications.c"
	}
}

void
notifications_operation_blocked (GtkWindow* win,
                                 const gchar* title,
                                 const gchar* body)
{
#line 53 "../app/Notifications.vala"
	g_return_if_fail (win != NULL);
#line 53 "../app/Notifications.vala"
	g_return_if_fail (title != NULL);
#line 56 "../app/Notifications.vala"
	if (!notifications_window_is_active (win)) {
#line 57 "../app/Notifications.vala"
		notifications_send_status (title, body, G_NOTIFICATION_PRIORITY_NORMAL);
#line 275 "Notifications.c"
	}
}

void
notifications_operation_unblocked (void)
{
#line 62 "../app/Notifications.vala"
	notifications_withdraw_status ();
#line 284 "Notifications.c"
}

void
notifications_attention_needed (GtkWindow* win,
                                const gchar* title,
                                const gchar* body)
{
#line 65 "../app/Notifications.vala"
	g_return_if_fail (win != NULL);
#line 65 "../app/Notifications.vala"
	g_return_if_fail (title != NULL);
#line 68 "../app/Notifications.vala"
	if (!notifications_window_is_active (win)) {
#line 69 "../app/Notifications.vala"
		notifications_send_status (title, body, G_NOTIFICATION_PRIORITY_HIGH);
#line 300 "Notifications.c"
	}
}

void
notifications_prompt (void)
{
	GNotification* note = NULL;
	GNotification* _tmp0_;
	GApplication* _tmp1_;
#line 74 "../app/Notifications.vala"
	deja_dup_update_prompt_time (FALSE);
#line 76 "../app/Notifications.vala"
	_tmp0_ = notifications_make_note (_ ("Keep your files safe by backing up regularly"), _ ("Important documents, data, and settings can be " "protected by storing them in a backup. In the " "case of a disaster, you would be able to recover " "them from that backup."));
#line 76 "../app/Notifications.vala"
	note = _tmp0_;
#line 81 "../app/Notifications.vala"
	g_notification_set_default_action (note, "app.prompt-ok");
#line 82 "../app/Notifications.vala"
	g_notification_add_button (note, _ ("Don’t Show Again"), "app.prompt-cancel");
#line 83 "../app/Notifications.vala"
	g_notification_add_button (note, _ ("Open Backups"), "app.prompt-ok");
#line 85 "../app/Notifications.vala"
	_tmp1_ = g_application_get_default ();
#line 85 "../app/Notifications.vala"
	g_application_send_notification (_tmp1_, "prompt", note);
#line 72 "../app/Notifications.vala"
	_g_object_unref0 (note);
#line 328 "Notifications.c"
}

void
notifications_close_all (void)
{
	GApplication* _tmp0_;
#line 90 "../app/Notifications.vala"
	notifications_withdraw_status ();
#line 91 "../app/Notifications.vala"
	_tmp0_ = g_application_get_default ();
#line 91 "../app/Notifications.vala"
	g_application_withdraw_notification (_tmp0_, "prompt");
#line 341 "Notifications.c"
}

static GNotification*
notifications_make_note (const gchar* title,
                         const gchar* body)
{
	GNotification* note = NULL;
	GNotification* _tmp0_;
	gchar* icon_env = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GNotification* _tmp14_;
	GNotification* result;
#line 94 "../app/Notifications.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 96 "../app/Notifications.vala"
	_tmp0_ = g_notification_new (title);
#line 96 "../app/Notifications.vala"
	note = _tmp0_;
#line 97 "../app/Notifications.vala"
	if (body != NULL) {
#line 364 "Notifications.c"
		GNotification* _tmp1_;
#line 98 "../app/Notifications.vala"
		_tmp1_ = note;
#line 98 "../app/Notifications.vala"
		g_notification_set_body (_tmp1_, body);
#line 370 "Notifications.c"
	}
#line 102 "../app/Notifications.vala"
	_tmp2_ = g_getenv ("DEJA_DUP_NOTIFICATION_ICON");
#line 102 "../app/Notifications.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 102 "../app/Notifications.vala"
	icon_env = _tmp3_;
#line 103 "../app/Notifications.vala"
	_tmp4_ = icon_env;
#line 103 "../app/Notifications.vala"
	if (_tmp4_ != NULL) {
#line 382 "Notifications.c"
		GNotification* _tmp5_;
		const gchar* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		GFileIcon* _tmp9_;
		GFileIcon* _tmp10_;
#line 104 "../app/Notifications.vala"
		_tmp5_ = note;
#line 104 "../app/Notifications.vala"
		_tmp6_ = icon_env;
#line 104 "../app/Notifications.vala"
		_tmp7_ = g_file_new_for_path (_tmp6_);
#line 104 "../app/Notifications.vala"
		_tmp8_ = _tmp7_;
#line 104 "../app/Notifications.vala"
		_tmp9_ = (GFileIcon*) g_file_icon_new (_tmp8_);
#line 104 "../app/Notifications.vala"
		_tmp10_ = _tmp9_;
#line 104 "../app/Notifications.vala"
		g_notification_set_icon (_tmp5_, (GIcon*) _tmp10_);
#line 104 "../app/Notifications.vala"
		_g_object_unref0 (_tmp10_);
#line 104 "../app/Notifications.vala"
		_g_object_unref0 (_tmp8_);
#line 407 "Notifications.c"
	} else {
		GNotification* _tmp11_;
		GThemedIcon* _tmp12_;
		GThemedIcon* _tmp13_;
#line 106 "../app/Notifications.vala"
		_tmp11_ = note;
#line 106 "../app/Notifications.vala"
		_tmp12_ = (GThemedIcon*) g_themed_icon_new (ICON_NAME);
#line 106 "../app/Notifications.vala"
		_tmp13_ = _tmp12_;
#line 106 "../app/Notifications.vala"
		g_notification_set_icon (_tmp11_, (GIcon*) _tmp13_);
#line 106 "../app/Notifications.vala"
		_g_object_unref0 (_tmp13_);
#line 422 "Notifications.c"
	}
#line 110 "../app/Notifications.vala"
	_tmp14_ = note;
#line 110 "../app/Notifications.vala"
	g_notification_set_default_action (_tmp14_, "app.show");
#line 112 "../app/Notifications.vala"
	result = note;
#line 112 "../app/Notifications.vala"
	_g_free0 (icon_env);
#line 112 "../app/Notifications.vala"
	return result;
#line 434 "Notifications.c"
}

static void
notifications_send_status (const gchar* title,
                           const gchar* body,
                           GNotificationPriority priority)
{
	GNotification* note = NULL;
	GNotification* _tmp0_;
	GApplication* _tmp1_;
#line 115 "../app/Notifications.vala"
	g_return_if_fail (title != NULL);
#line 118 "../app/Notifications.vala"
	_tmp0_ = notifications_make_note (title, body);
#line 118 "../app/Notifications.vala"
	note = _tmp0_;
#line 119 "../app/Notifications.vala"
	g_notification_set_priority (note, priority);
#line 120 "../app/Notifications.vala"
	_tmp1_ = g_application_get_default ();
#line 120 "../app/Notifications.vala"
	g_application_send_notification (_tmp1_, "backup-status", note);
#line 115 "../app/Notifications.vala"
	_g_object_unref0 (note);
#line 459 "Notifications.c"
}

static void
notifications_withdraw_status (void)
{
	GApplication* _tmp0_;
#line 125 "../app/Notifications.vala"
	_tmp0_ = g_application_get_default ();
#line 125 "../app/Notifications.vala"
	g_application_withdraw_notification (_tmp0_, "backup-status");
#line 470 "Notifications.c"
}

static gboolean
notifications_window_is_active (GtkWindow* win)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 128 "../app/Notifications.vala"
	g_return_val_if_fail (win != NULL, FALSE);
#line 130 "../app/Notifications.vala"
	g_object_get (win, "is-active", &_tmp1_, NULL);
#line 130 "../app/Notifications.vala"
	_tmp2_ = _tmp1_;
#line 130 "../app/Notifications.vala"
	if (_tmp2_) {
#line 488 "Notifications.c"
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 130 "../app/Notifications.vala"
		_tmp3_ = gtk_widget_get_visible ((GtkWidget*) win);
#line 130 "../app/Notifications.vala"
		_tmp4_ = _tmp3_;
#line 130 "../app/Notifications.vala"
		_tmp0_ = _tmp4_;
#line 497 "Notifications.c"
	} else {
#line 130 "../app/Notifications.vala"
		_tmp0_ = FALSE;
#line 501 "Notifications.c"
	}
#line 130 "../app/Notifications.vala"
	result = _tmp0_;
#line 130 "../app/Notifications.vala"
	return result;
#line 507 "Notifications.c"
}

Notifications*
notifications_construct (GType object_type)
{
	Notifications * self = NULL;
#line 9 "../app/Notifications.vala"
	self = (Notifications*) g_object_new (object_type, NULL);
#line 9 "../app/Notifications.vala"
	return self;
#line 518 "Notifications.c"
}

Notifications*
notifications_new (void)
{
#line 9 "../app/Notifications.vala"
	return notifications_construct (TYPE_NOTIFICATIONS);
#line 526 "Notifications.c"
}

static void
notifications_class_init (NotificationsClass * klass,
                          gpointer klass_data)
{
#line 9 "../app/Notifications.vala"
	notifications_parent_class = g_type_class_peek_parent (klass);
#line 535 "Notifications.c"
}

static void
notifications_instance_init (Notifications * self,
                             gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
notifications_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NotificationsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notifications_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Notifications), 0, (GInstanceInitFunc) notifications_instance_init, NULL };
	GType notifications_type_id;
	notifications_type_id = g_type_register_static (G_TYPE_OBJECT, "Notifications", &g_define_type_info, 0);
	return notifications_type_id;
}

GType
notifications_get_type (void)
{
	static gsize notifications_type_id__once = 0;
	if (g_once_init_enter (&notifications_type_id__once)) {
		GType notifications_type_id;
		notifications_type_id = notifications_get_type_once ();
		g_once_init_leave (&notifications_type_id__once, notifications_type_id);
	}
	return notifications_type_id__once;
}

