/* Rclone.c generated by valac 0.56.13, the Vala compiler
 * generated from Rclone.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Michael Terry
 */

#include <glib-object.h>
#include "deja.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_RCLONE (rclone_get_type ())
#define RCLONE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RCLONE, Rclone))
#define RCLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RCLONE, RcloneClass))
#define IS_RCLONE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RCLONE))
#define IS_RCLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RCLONE))
#define RCLONE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RCLONE, RcloneClass))

typedef struct _Rclone Rclone;
typedef struct _RcloneClass RcloneClass;
typedef struct _RclonePrivate RclonePrivate;
enum  {
	RCLONE_0_PROPERTY,
	RCLONE_NUM_PROPERTIES
};
static GParamSpec* rclone_properties[RCLONE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Rclone {
	GObject parent_instance;
	RclonePrivate * priv;
};

struct _RcloneClass {
	GObjectClass parent_class;
};

static gpointer rclone_parent_class = NULL;

VALA_EXTERN GType rclone_get_type (void) G_GNUC_CONST ;
static gchar* rclone_fill_envp_from_google (DejaDupBackendGoogle* google_backend,
                                     GList** envp);
static gchar* rclone_fill_envp_from_microsoft (DejaDupBackendMicrosoft* microsoft_backend,
                                        GList** envp);
VALA_EXTERN gchar* deja_dup_backend_microsoft_get_folder (DejaDupBackendMicrosoft* self);
VALA_EXTERN gchar* rclone_fill_envp_from_backend (DejaDupBackend* backend,
                                      GList** envp);
VALA_EXTERN gchar* rclone_rclone_command (void);
VALA_EXTERN Rclone* rclone_new (void);
VALA_EXTERN Rclone* rclone_construct (GType object_type);
static GType rclone_get_type_once (void);

static gchar*
rclone_fill_envp_from_google (DejaDupBackendGoogle* google_backend,
                              GList** envp)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* result;
#line 11 "../libdeja/Rclone.vala"
	g_return_val_if_fail (google_backend != NULL, NULL);
#line 13 "../libdeja/Rclone.vala"
	_tmp0_ = g_strdup ("RCLONE_CONFIG_DEJADUPDRIVE_TYPE=drive");
#line 13 "../libdeja/Rclone.vala"
	*envp = g_list_append (*envp, _tmp0_);
#line 14 "../libdeja/Rclone.vala"
	_tmp1_ = g_strdup ("RCLONE_CONFIG_DEJADUPDRIVE_CLIENT_ID=" GOOGLE_CLIENT_ID);
#line 14 "../libdeja/Rclone.vala"
	*envp = g_list_append (*envp, _tmp1_);
#line 15 "../libdeja/Rclone.vala"
	_tmp2_ = deja_dup_backend_oauth_get_full_token ((DejaDupBackendOAuth*) google_backend);
#line 15 "../libdeja/Rclone.vala"
	_tmp3_ = _tmp2_;
#line 15 "../libdeja/Rclone.vala"
	_tmp4_ = g_strconcat ("RCLONE_CONFIG_DEJADUPDRIVE_TOKEN=", _tmp3_, NULL);
#line 15 "../libdeja/Rclone.vala"
	*envp = g_list_append (*envp, _tmp4_);
#line 16 "../libdeja/Rclone.vala"
	_tmp5_ = g_strdup ("RCLONE_CONFIG_DEJADUPDRIVE_SCOPE=drive.file");
#line 16 "../libdeja/Rclone.vala"
	*envp = g_list_append (*envp, _tmp5_);
#line 17 "../libdeja/Rclone.vala"
	_tmp6_ = g_strdup ("RCLONE_CONFIG_DEJADUPDRIVE_USE_TRASH=false");
#line 17 "../libdeja/Rclone.vala"
	*envp = g_list_append (*envp, _tmp6_);
#line 18 "../libdeja/Rclone.vala"
	_tmp7_ = deja_dup_backend_google_get_folder (google_backend);
#line 18 "../libdeja/Rclone.vala"
	_tmp8_ = _tmp7_;
#line 18 "../libdeja/Rclone.vala"
	_tmp9_ = g_strconcat ("dejadupdrive:", _tmp8_, NULL);
#line 18 "../libdeja/Rclone.vala"
	_tmp10_ = _tmp9_;
#line 18 "../libdeja/Rclone.vala"
	_g_free0 (_tmp8_);
#line 18 "../libdeja/Rclone.vala"
	result = _tmp10_;
#line 18 "../libdeja/Rclone.vala"
	return result;
#line 115 "Rclone.c"
}

static gchar*
rclone_fill_envp_from_microsoft (DejaDupBackendMicrosoft* microsoft_backend,
                                 GList** envp)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* result;
#line 21 "../libdeja/Rclone.vala"
	g_return_val_if_fail (microsoft_backend != NULL, NULL);
#line 23 "../libdeja/Rclone.vala"
	_tmp0_ = g_strdup ("RCLONE_CONFIG_DEJADUPONEDRIVE_TYPE=onedrive");
#line 23 "../libdeja/Rclone.vala"
	*envp = g_list_append (*envp, _tmp0_);
#line 24 "../libdeja/Rclone.vala"
	_tmp1_ = g_strdup ("RCLONE_CONFIG_DEJADUPONEDRIVE_CLIENT_ID=" MICROSOFT_CLIENT_ID);
#line 24 "../libdeja/Rclone.vala"
	*envp = g_list_append (*envp, _tmp1_);
#line 25 "../libdeja/Rclone.vala"
	_tmp2_ = deja_dup_backend_oauth_get_full_token ((DejaDupBackendOAuth*) microsoft_backend);
#line 25 "../libdeja/Rclone.vala"
	_tmp3_ = _tmp2_;
#line 25 "../libdeja/Rclone.vala"
	_tmp4_ = g_strconcat ("RCLONE_CONFIG_DEJADUPONEDRIVE_TOKEN=", _tmp3_, NULL);
#line 25 "../libdeja/Rclone.vala"
	*envp = g_list_append (*envp, _tmp4_);
#line 26 "../libdeja/Rclone.vala"
	_tmp5_ = deja_dup_backend_microsoft_get_drive_id (microsoft_backend);
#line 26 "../libdeja/Rclone.vala"
	_tmp6_ = _tmp5_;
#line 26 "../libdeja/Rclone.vala"
	_tmp7_ = g_strconcat ("RCLONE_CONFIG_DEJADUPONEDRIVE_DRIVE_ID=", _tmp6_, NULL);
#line 26 "../libdeja/Rclone.vala"
	*envp = g_list_append (*envp, _tmp7_);
#line 27 "../libdeja/Rclone.vala"
	_tmp8_ = g_strdup ("RCLONE_CONFIG_DEJADUPONEDRIVE_DRIVE_TYPE=personal");
#line 27 "../libdeja/Rclone.vala"
	*envp = g_list_append (*envp, _tmp8_);
#line 28 "../libdeja/Rclone.vala"
	_tmp9_ = deja_dup_backend_microsoft_get_folder (microsoft_backend);
#line 28 "../libdeja/Rclone.vala"
	_tmp10_ = _tmp9_;
#line 28 "../libdeja/Rclone.vala"
	_tmp11_ = g_strconcat ("dejaduponedrive:", _tmp10_, NULL);
#line 28 "../libdeja/Rclone.vala"
	_tmp12_ = _tmp11_;
#line 28 "../libdeja/Rclone.vala"
	_g_free0 (_tmp10_);
#line 28 "../libdeja/Rclone.vala"
	result = _tmp12_;
#line 28 "../libdeja/Rclone.vala"
	return result;
#line 180 "Rclone.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 33 "../libdeja/Rclone.vala"
	return self ? g_object_ref (self) : NULL;
#line 188 "Rclone.c"
}

gchar*
rclone_fill_envp_from_backend (DejaDupBackend* backend,
                               GList** envp)
{
	DejaDupBackendGoogle* google_backend = NULL;
	DejaDupBackendGoogle* _tmp0_;
	DejaDupBackendGoogle* _tmp1_;
	DejaDupBackendMicrosoft* microsoft_backend = NULL;
	DejaDupBackendMicrosoft* _tmp4_;
	DejaDupBackendMicrosoft* _tmp5_;
	gchar* result;
#line 31 "../libdeja/Rclone.vala"
	g_return_val_if_fail (backend != NULL, NULL);
#line 33 "../libdeja/Rclone.vala"
	_tmp0_ = _g_object_ref0 (DEJA_DUP_IS_BACKEND_GOOGLE (backend) ? ((DejaDupBackendGoogle*) backend) : NULL);
#line 33 "../libdeja/Rclone.vala"
	google_backend = _tmp0_;
#line 34 "../libdeja/Rclone.vala"
	_tmp1_ = google_backend;
#line 34 "../libdeja/Rclone.vala"
	if (_tmp1_ != NULL) {
#line 212 "Rclone.c"
		DejaDupBackendGoogle* _tmp2_;
		gchar* _tmp3_;
#line 35 "../libdeja/Rclone.vala"
		_tmp2_ = google_backend;
#line 35 "../libdeja/Rclone.vala"
		_tmp3_ = rclone_fill_envp_from_google (_tmp2_, envp);
#line 35 "../libdeja/Rclone.vala"
		result = _tmp3_;
#line 35 "../libdeja/Rclone.vala"
		_g_object_unref0 (google_backend);
#line 35 "../libdeja/Rclone.vala"
		return result;
#line 225 "Rclone.c"
	}
#line 37 "../libdeja/Rclone.vala"
	_tmp4_ = _g_object_ref0 (DEJA_DUP_IS_BACKEND_MICROSOFT (backend) ? ((DejaDupBackendMicrosoft*) backend) : NULL);
#line 37 "../libdeja/Rclone.vala"
	microsoft_backend = _tmp4_;
#line 38 "../libdeja/Rclone.vala"
	_tmp5_ = microsoft_backend;
#line 38 "../libdeja/Rclone.vala"
	if (_tmp5_ != NULL) {
#line 235 "Rclone.c"
		DejaDupBackendMicrosoft* _tmp6_;
		gchar* _tmp7_;
#line 39 "../libdeja/Rclone.vala"
		_tmp6_ = microsoft_backend;
#line 39 "../libdeja/Rclone.vala"
		_tmp7_ = rclone_fill_envp_from_microsoft (_tmp6_, envp);
#line 39 "../libdeja/Rclone.vala"
		result = _tmp7_;
#line 39 "../libdeja/Rclone.vala"
		_g_object_unref0 (microsoft_backend);
#line 39 "../libdeja/Rclone.vala"
		_g_object_unref0 (google_backend);
#line 39 "../libdeja/Rclone.vala"
		return result;
#line 250 "Rclone.c"
	}
#line 41 "../libdeja/Rclone.vala"
	result = NULL;
#line 41 "../libdeja/Rclone.vala"
	_g_object_unref0 (microsoft_backend);
#line 41 "../libdeja/Rclone.vala"
	_g_object_unref0 (google_backend);
#line 41 "../libdeja/Rclone.vala"
	return result;
#line 260 "Rclone.c"
}

gchar*
rclone_rclone_command (void)
{
	gchar* testing_str = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gchar* result;
#line 46 "../libdeja/Rclone.vala"
	_tmp0_ = g_getenv ("DEJA_DUP_TESTING");
#line 46 "../libdeja/Rclone.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 46 "../libdeja/Rclone.vala"
	testing_str = _tmp1_;
#line 47 "../libdeja/Rclone.vala"
	_tmp3_ = testing_str;
#line 47 "../libdeja/Rclone.vala"
	if (_tmp3_ != NULL) {
#line 282 "Rclone.c"
		const gchar* _tmp4_;
#line 47 "../libdeja/Rclone.vala"
		_tmp4_ = testing_str;
#line 47 "../libdeja/Rclone.vala"
		_tmp2_ = atoi (_tmp4_) > 0;
#line 288 "Rclone.c"
	} else {
#line 47 "../libdeja/Rclone.vala"
		_tmp2_ = FALSE;
#line 292 "Rclone.c"
	}
#line 47 "../libdeja/Rclone.vala"
	if (_tmp2_) {
#line 296 "Rclone.c"
		gchar* _tmp5_;
#line 48 "../libdeja/Rclone.vala"
		_tmp5_ = g_strdup ("rclone");
#line 48 "../libdeja/Rclone.vala"
		result = _tmp5_;
#line 48 "../libdeja/Rclone.vala"
		_g_free0 (testing_str);
#line 48 "../libdeja/Rclone.vala"
		return result;
#line 306 "Rclone.c"
	} else {
		gchar* _tmp6_;
#line 50 "../libdeja/Rclone.vala"
		_tmp6_ = g_strdup (RCLONE_COMMAND);
#line 50 "../libdeja/Rclone.vala"
		result = _tmp6_;
#line 50 "../libdeja/Rclone.vala"
		_g_free0 (testing_str);
#line 50 "../libdeja/Rclone.vala"
		return result;
#line 317 "Rclone.c"
	}
}

Rclone*
rclone_construct (GType object_type)
{
	Rclone * self = NULL;
#line 9 "../libdeja/Rclone.vala"
	self = (Rclone*) g_object_new (object_type, NULL);
#line 9 "../libdeja/Rclone.vala"
	return self;
#line 329 "Rclone.c"
}

Rclone*
rclone_new (void)
{
#line 9 "../libdeja/Rclone.vala"
	return rclone_construct (TYPE_RCLONE);
#line 337 "Rclone.c"
}

static void
rclone_class_init (RcloneClass * klass,
                   gpointer klass_data)
{
#line 9 "../libdeja/Rclone.vala"
	rclone_parent_class = g_type_class_peek_parent (klass);
#line 346 "Rclone.c"
}

static void
rclone_instance_init (Rclone * self,
                      gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
rclone_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RcloneClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rclone_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Rclone), 0, (GInstanceInitFunc) rclone_instance_init, NULL };
	GType rclone_type_id;
	rclone_type_id = g_type_register_static (G_TYPE_OBJECT, "Rclone", &g_define_type_info, 0);
	return rclone_type_id;
}

GType
rclone_get_type (void)
{
	static gsize rclone_type_id__once = 0;
	if (g_once_init_enter (&rclone_type_id__once)) {
		GType rclone_type_id;
		rclone_type_id = rclone_get_type_once ();
		g_once_init_leave (&rclone_type_id__once, rclone_type_id);
	}
	return rclone_type_id__once;
}

